/*!999999\- enable the sandbox mode */ 
-- MariaDB dump 10.19  Distrib 10.11.8-MariaDB, for Linux (x86_64)
--
-- Host: mysql.pai-cloud    Database: pai_screen_1782283103811162112
-- ------------------------------------------------------
-- Server version	8.0.30

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Temporary table structure for view `ads_all_car_count`
--

DROP TABLE IF EXISTS `ads_all_car_count`;
/*!50001 DROP VIEW IF EXISTS `ads_all_car_count`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `ads_all_car_count` AS SELECT
 1 AS `park_id`,
  1 AS `car_num` */;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `ads_date_parking_ratio`
--

DROP TABLE IF EXISTS `ads_date_parking_ratio`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ads_date_parking_ratio` (
  `in_park` decimal(25,0) NOT NULL DEFAULT '0',
  `area_count` decimal(32,0) NOT NULL DEFAULT '0',
  `ratio` decimal(29,4) NOT NULL DEFAULT '0.0000',
  `park_id` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL,
  `tenant_id` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL,
  `enter_time` datetime DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='ads_日车位饱和率';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `ads_period_max_and_min_in_park_ratio`
--

DROP TABLE IF EXISTS `ads_period_max_and_min_in_park_ratio`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ads_period_max_and_min_in_park_ratio` (
  `check_date` datetime DEFAULT NULL COMMENT '数据计算日期，不含小时分',
  `max_in_park_count` int DEFAULT NULL COMMENT '在园车辆数',
  `min_in_park_count` int DEFAULT NULL COMMENT '在园车辆数',
  `area_count` decimal(32,0) DEFAULT NULL COMMENT '车位数',
  `max_in_park_ratio` decimal(14,4) DEFAULT NULL COMMENT '最大饱和率',
  `min_in_park_ratio` decimal(14,4) DEFAULT NULL COMMENT '最小饱和率',
  `park_id` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL,
  `tenant_id` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='ads_动态期间每天最大与最小车位饱和率';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dim_date`
--

DROP TABLE IF EXISTS `dim_date`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dim_date` (
  `id` bigint NOT NULL AUTO_INCREMENT COMMENT '主键',
  `date_key` datetime DEFAULT NULL,
  `month_key` int DEFAULT NULL,
  `year_key` int DEFAULT NULL,
  `tenant_id` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '租户ID',
  `park_id` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '园区ID',
  `is_deleted` int DEFAULT '0' COMMENT '是否已删除(0:否 1:是）',
  `date_name` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL,
  `status` int DEFAULT '0' COMMENT '状态',
  `create_by` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '创建人',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '修改人',
  `update_time` datetime DEFAULT NULL COMMENT '修改时间',
  `year_name` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL,
  `month_name` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL,
  `year_month_name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  KEY `idx_start_date` (`date_key`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=2786 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='dim_日期表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Temporary table structure for view `dim_month`
--

DROP TABLE IF EXISTS `dim_month`;
/*!50001 DROP VIEW IF EXISTS `dim_month`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dim_month` AS SELECT
 1 AS `year_key`,
  1 AS `month_key`,
  1 AS `start_date`,
  1 AS `end_date` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dim_park`
--

DROP TABLE IF EXISTS `dim_park`;
/*!50001 DROP VIEW IF EXISTS `dim_park`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dim_park` AS SELECT
 1 AS `park_id`,
  1 AS `park_code`,
  1 AS `park_ent_id`,
  1 AS `park_domain`,
  1 AS `park_type`,
  1 AS `park_scale`,
  1 AS `park_area`,
  1 AS `park_floor_area`,
  1 AS `park_phone`,
  1 AS `park_address`,
  1 AS `park_status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `remark`,
  1 AS `park_name`,
  1 AS `park_logo`,
  1 AS `park_province`,
  1 AS `park_city`,
  1 AS `park_region`,
  1 AS `area_code`,
  1 AS `virtual_type`,
  1 AS `contact_person`,
  1 AS `contact_number`,
  1 AS `group_preset_id`,
  1 AS `group_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dim_park_space_room`
--

DROP TABLE IF EXISTS `dim_park_space_room`;
/*!50001 DROP VIEW IF EXISTS `dim_park_space_room`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dim_park_space_room` AS SELECT
 1 AS `id`,
  1 AS `park_id`,
  1 AS `renting_selling`,
  1 AS `renting_selling_desc`,
  1 AS `room_code`,
  1 AS `room_name`,
  1 AS `area_covered`,
  1 AS `built_area`,
  1 AS `house_structure`,
  1 AS `kit_id`,
  1 AS `purpose`,
  1 AS `room_describe`,
  1 AS `floor_id`,
  1 AS `image`,
  1 AS `is_order`,
  1 AS `tenant_id`,
  1 AS `is_lock`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `room_status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `purpose_id`,
  1 AS `floor_name`,
  1 AS `building_id`,
  1 AS `building_code`,
  1 AS `building_name`,
  1 AS `area_id`,
  1 AS `area_name` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dim_year`
--

DROP TABLE IF EXISTS `dim_year`;
/*!50001 DROP VIEW IF EXISTS `dim_year`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dim_year` AS SELECT
 1 AS `year_key`,
  1 AS `start_date`,
  1 AS `end_date` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_area_setting`
--

DROP TABLE IF EXISTS `dwd_area_setting`;
/*!50001 DROP VIEW IF EXISTS `dwd_area_setting`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_area_setting` AS SELECT
 1 AS `source_id`,
  1 AS `area_name`,
  1 AS `area_count`,
  1 AS `area_num`,
  1 AS `config_id`,
  1 AS `month_id`,
  1 AS `free_num`,
  1 AS `park_id`,
  1 AS `is_show`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_time`,
  1 AS `update_by`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `area_key` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_business_plan_detail`
--

DROP TABLE IF EXISTS `dwd_business_plan_detail`;
/*!50001 DROP VIEW IF EXISTS `dwd_business_plan_detail`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_business_plan_detail` AS SELECT
 1 AS `id`,
  1 AS `plan_id`,
  1 AS `indicator`,
  1 AS `indicator_name`,
  1 AS `indicator_val`,
  1 AS `indicator_unit`,
  1 AS `executor`,
  1 AS `executor_name`,
  1 AS `remark`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_business_plan_plan`
--

DROP TABLE IF EXISTS `dwd_business_plan_plan`;
/*!50001 DROP VIEW IF EXISTS `dwd_business_plan_plan`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_business_plan_plan` AS SELECT
 1 AS `id`,
  1 AS `dept`,
  1 AS `dept_name`,
  1 AS `year`,
  1 AS `type`,
  1 AS `type_name`,
  1 AS `section`,
  1 AS `section_name`,
  1 AS `start`,
  1 AS `end`,
  1 AS `remark`,
  1 AS `contract_num`,
  1 AS `sale_amount`,
  1 AS `lease_amount`,
  1 AS `land_amount`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `park_name`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_by_name`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_car_free_manage`
--

DROP TABLE IF EXISTS `dwd_car_free_manage`;
/*!50001 DROP VIEW IF EXISTS `dwd_car_free_manage`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_car_free_manage` AS SELECT
 1 AS `source_id`,
  1 AS `car_num`,
  1 AS `car_contacts`,
  1 AS `user_id`,
  1 AS `car_phone`,
  1 AS `company_name`,
  1 AS `company_id`,
  1 AS `free_time_encryption`,
  1 AS `free_time`,
  1 AS `synchronization`,
  1 AS `car_unique_id`,
  1 AS `park_id`,
  1 AS `is_renew`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_time`,
  1 AS `update_by`,
  1 AS `is_deleted`,
  1 AS `status` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_car_in_record`
--

DROP TABLE IF EXISTS `dwd_car_in_record`;
/*!50001 DROP VIEW IF EXISTS `dwd_car_in_record`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_car_in_record` AS SELECT
 1 AS `id`,
  1 AS `car_num`,
  1 AS `record_id`,
  1 AS `enter_area`,
  1 AS `tenant_id`,
  1 AS `enter_time`,
  1 AS `park_id`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_time`,
  1 AS `update_by`,
  1 AS `is_deleted`,
  1 AS `status` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_car_manage`
--

DROP TABLE IF EXISTS `dwd_car_manage`;
/*!50001 DROP VIEW IF EXISTS `dwd_car_manage`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_car_manage` AS SELECT
 1 AS `source_id`,
  1 AS `car_num`,
  1 AS `car_unique_id`,
  1 AS `user_id`,
  1 AS `area_id`,
  1 AS `synchronization`,
  1 AS `remarks`,
  1 AS `park_id`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_time`,
  1 AS `update_by`,
  1 AS `is_free`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `is_black` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_cash_pledge`
--

DROP TABLE IF EXISTS `dwd_cash_pledge`;
/*!50001 DROP VIEW IF EXISTS `dwd_cash_pledge`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_cash_pledge` AS SELECT
 1 AS `id`,
  1 AS `code`,
  1 AS `deposit_type`,
  1 AS `customer_id`,
  1 AS `customer_name`,
  1 AS `contract_id`,
  1 AS `amount`,
  1 AS `pending`,
  1 AS `balance`,
  1 AS `type`,
  1 AS `type_desc`,
  1 AS `remark`,
  1 AS `payee_id`,
  1 AS `receipt_id`,
  1 AS `contract_name`,
  1 AS `deposit_name`,
  1 AS `creditable_balance`,
  1 AS `receipt_request_id`,
  1 AS `is_pushed`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_clue_enterprise`
--

DROP TABLE IF EXISTS `dwd_clue_enterprise`;
/*!50001 DROP VIEW IF EXISTS `dwd_clue_enterprise`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_clue_enterprise` AS SELECT
 1 AS `id`,
  1 AS `enterprise_id`,
  1 AS `name`,
  1 AS `contact`,
  1 AS `phone`,
  1 AS `source`,
  1 AS `follower`,
  1 AS `follower_name`,
  1 AS `follow_status`,
  1 AS `follow_status_desc`,
  1 AS `tenant_id`,
  1 AS `channel_id`,
  1 AS `channel_name`,
  1 AS `config_id`,
  1 AS `tag`,
  1 AS `park_id`,
  1 AS `park_name`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `dept_id`,
  1 AS `dept_name`,
  1 AS `ent_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_clue_source_channel`
--

DROP TABLE IF EXISTS `dwd_clue_source_channel`;
/*!50001 DROP VIEW IF EXISTS `dwd_clue_source_channel`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_clue_source_channel` AS SELECT
 1 AS `id`,
  1 AS `dict_label`,
  1 AS `dict_value`,
  1 AS `suite_id`,
  1 AS `suite_code`,
  1 AS `version`,
  1 AS `dict_name`,
  1 AS `tenant_id`,
  1 AS `dict_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_enterprise`
--

DROP TABLE IF EXISTS `dwd_enterprise`;
/*!50001 DROP VIEW IF EXISTS `dwd_enterprise`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_enterprise` AS SELECT
 1 AS `enterprise_id`,
  1 AS `id`,
  1 AS `name`,
  1 AS `alias`,
  1 AS `history_names`,
  1 AS `eng_name`,
  1 AS `tax_number`,
  1 AS `credit_code`,
  1 AS `industry`,
  1 AS `estiblish_time`,
  1 AS `from_time`,
  1 AS `to_time`,
  1 AS `reg_status`,
  1 AS `is_micro_ent`,
  1 AS `org_number`,
  1 AS `category_big`,
  1 AS `legal_person_name`,
  1 AS `reg_capital`,
  1 AS `reg_location`,
  1 AS `origin_id`,
  1 AS `is_sync`,
  1 AS `ent_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `category`,
  1 AS `category_middle`,
  1 AS `category_small`,
  1 AS `history_name_list`,
  1 AS `staff_num_range`,
  1 AS `social_staff_num`,
  1 AS `business_scope`,
  1 AS `type`,
  1 AS `company_org_type`,
  1 AS `tags`,
  1 AS `percentile_score`,
  1 AS `base`,
  1 AS `city`,
  1 AS `district`,
  1 AS `reg_number`,
  1 AS `reg_capital_currency`,
  1 AS `actual_capital`,
  1 AS `actual_capital_currency`,
  1 AS `regInstitute`,
  1 AS `approved_time`,
  1 AS `bond_num`,
  1 AS `bond_name`,
  1 AS `used_bond_name`,
  1 AS `bond_type`,
  1 AS `revoke_date`,
  1 AS `revoke_reason`,
  1 AS `cancel_date`,
  1 AS `cancel_reason`,
  1 AS `logo`,
  1 AS `is_fill`,
  1 AS `tenant_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_enterprise_biz`
--

DROP TABLE IF EXISTS `dwd_enterprise_biz`;
/*!50001 DROP VIEW IF EXISTS `dwd_enterprise_biz`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_enterprise_biz` AS SELECT
 1 AS `id`,
  1 AS `enterprise_id`,
  1 AS `enterprise_name`,
  1 AS `milestone`,
  1 AS `milestone_desc`,
  1 AS `type`,
  1 AS `type_desc`,
  1 AS `biz_id`,
  1 AS `source`,
  1 AS `name`,
  1 AS `phone`,
  1 AS `dept_id`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `park_name`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_by_name`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_enterprise_ent_bind`
--

DROP TABLE IF EXISTS `dwd_enterprise_ent_bind`;
/*!50001 DROP VIEW IF EXISTS `dwd_enterprise_ent_bind`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_enterprise_ent_bind` AS SELECT
 1 AS `id`,
  1 AS `enterprise_id`,
  1 AS `ent_id`,
  1 AS `phone`,
  1 AS `contact`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_fee_category`
--

DROP TABLE IF EXISTS `dwd_fee_category`;
/*!50001 DROP VIEW IF EXISTS `dwd_fee_category`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_fee_category` AS SELECT
 1 AS `id`,
  1 AS `category_name`,
  1 AS `code`,
  1 AS `parent_id`,
  1 AS `parent_code`,
  1 AS `level`,
  1 AS `fee_type`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_fee_item`
--

DROP TABLE IF EXISTS `dwd_fee_item`;
/*!50001 DROP VIEW IF EXISTS `dwd_fee_item`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_fee_item` AS SELECT
 1 AS `id`,
  1 AS `name`,
  1 AS `code`,
  1 AS `category_id`,
  1 AS `category_code`,
  1 AS `fee_type`,
  1 AS `univalent`,
  1 AS `late_fee_ratio`,
  1 AS `monthly_type`,
  1 AS `fee_unit`,
  1 AS `meter_class`,
  1 AS `meter_type`,
  1 AS `remark`,
  1 AS `payee_id`,
  1 AS `payee_name`,
  1 AS `is_sys`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_finance_intention`
--

DROP TABLE IF EXISTS `dwd_finance_intention`;
/*!50001 DROP VIEW IF EXISTS `dwd_finance_intention`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_finance_intention` AS SELECT
 1 AS `id`,
  1 AS `code`,
  1 AS `customer_id`,
  1 AS `customer_name`,
  1 AS `intention_id`,
  1 AS `intention_name`,
  1 AS `amount`,
  1 AS `received`,
  1 AS `balance`,
  1 AS `payee_id`,
  1 AS `business_type`,
  1 AS `receipt_request_id`,
  1 AS `operational_balance`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_lease_contract`
--

DROP TABLE IF EXISTS `dwd_lease_contract`;
/*!50001 DROP VIEW IF EXISTS `dwd_lease_contract`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_lease_contract` AS SELECT
 1 AS `id`,
  1 AS `associate_id`,
  1 AS `customer_id`,
  1 AS `customer_id_label`,
  1 AS `name`,
  1 AS `code`,
  1 AS `first_code`,
  1 AS `contact`,
  1 AS `phone`,
  1 AS `start_date`,
  1 AS `end_date`,
  1 AS `warning_days`,
  1 AS `decoration_days`,
  1 AS `is_decoration_free`,
  1 AS `is_have_property`,
  1 AS `payee_id`,
  1 AS `payee_id_label`,
  1 AS `annex`,
  1 AS `source_type`,
  1 AS `source_id`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `dept_id`,
  1 AS `dept_desc`,
  1 AS `change_type`,
  1 AS `effective_date`,
  1 AS `closing_date`,
  1 AS `email`,
  1 AS `warn_status`,
  1 AS `biz_type`,
  1 AS `biz_type_desc`,
  1 AS `is_reserve`,
  1 AS `is_locked`,
  1 AS `status`,
  1 AS `status_desc`,
  1 AS `sign_by`,
  1 AS `sign_date`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_lease_contract_building`
--

DROP TABLE IF EXISTS `dwd_lease_contract_building`;
/*!50001 DROP VIEW IF EXISTS `dwd_lease_contract_building`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_lease_contract_building` AS SELECT
 1 AS `id`,
  1 AS `contract_id`,
  1 AS `building_level`,
  1 AS `building_id`,
  1 AS `building_label`,
  1 AS `rental_area`,
  1 AS `building_code`,
  1 AS `change_type`,
  1 AS `floor_coefficient`,
  1 AS `associate_id`,
  1 AS `customer_id`,
  1 AS `customer_id_label`,
  1 AS `name`,
  1 AS `code`,
  1 AS `first_code`,
  1 AS `contact`,
  1 AS `phone`,
  1 AS `start_date`,
  1 AS `end_date`,
  1 AS `warning_days`,
  1 AS `decoration_days`,
  1 AS `is_decoration_free`,
  1 AS `is_have_property`,
  1 AS `payee_id`,
  1 AS `payee_id_label`,
  1 AS `annex`,
  1 AS `source_type`,
  1 AS `source_id`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `dept_id`,
  1 AS `effective_date`,
  1 AS `closing_date`,
  1 AS `email`,
  1 AS `warn_status`,
  1 AS `biz_type`,
  1 AS `is_reserve`,
  1 AS `is_locked`,
  1 AS `status`,
  1 AS `sign_by`,
  1 AS `sign_date`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_lease_intention`
--

DROP TABLE IF EXISTS `dwd_lease_intention`;
/*!50001 DROP VIEW IF EXISTS `dwd_lease_intention`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_lease_intention` AS SELECT
 1 AS `id`,
  1 AS `enterprise_id`,
  1 AS `enterprise_name`,
  1 AS `concat_person`,
  1 AS `concat_phone`,
  1 AS `source_id`,
  1 AS `estimate_into_time`,
  1 AS `area`,
  1 AS `price`,
  1 AS `price_unit`,
  1 AS `estimate_value`,
  1 AS `other_focus`,
  1 AS `dept_id`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `park_name`,
  1 AS `config_id`,
  1 AS `tags`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_by_name`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `is_pushed` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_lease_intention_focus`
--

DROP TABLE IF EXISTS `dwd_lease_intention_focus`;
/*!50001 DROP VIEW IF EXISTS `dwd_lease_intention_focus`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_lease_intention_focus` AS SELECT
 1 AS `id`,
  1 AS `intention_id`,
  1 AS `focus_id`,
  1 AS `focus_name`,
  1 AS `focus_items`,
  1 AS `focus_item_names`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_lease_subscribe`
--

DROP TABLE IF EXISTS `dwd_lease_subscribe`;
/*!50001 DROP VIEW IF EXISTS `dwd_lease_subscribe`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_lease_subscribe` AS SELECT
 1 AS `id`,
  1 AS `name`,
  1 AS `payee_id`,
  1 AS `payee_name`,
  1 AS `customer_id`,
  1 AS `customer_name`,
  1 AS `sign_date`,
  1 AS `follower`,
  1 AS `follower_name`,
  1 AS `start_date`,
  1 AS `end_date`,
  1 AS `pay_deadline`,
  1 AS `warning_days`,
  1 AS `decoration_days`,
  1 AS `is_decoration_free`,
  1 AS `annex`,
  1 AS `settle_park`,
  1 AS `settle_park_name`,
  1 AS `contract_id`,
  1 AS `contract_name`,
  1 AS `billable_area`,
  1 AS `total_price`,
  1 AS `dept_id`,
  1 AS `is_pushed`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_lease_subscribe_room`
--

DROP TABLE IF EXISTS `dwd_lease_subscribe_room`;
/*!50001 DROP VIEW IF EXISTS `dwd_lease_subscribe_room`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_lease_subscribe_room` AS SELECT
 1 AS `id`,
  1 AS `subscribe_id`,
  1 AS `room_id`,
  1 AS `path`,
  1 AS `room_name`,
  1 AS `area_covered`,
  1 AS `build_area`,
  1 AS `unit_price`,
  1 AS `total_price`,
  1 AS `billable_area`,
  1 AS `name`,
  1 AS `payee_id`,
  1 AS `payee_name`,
  1 AS `customer_id`,
  1 AS `customer_name`,
  1 AS `sign_date`,
  1 AS `follower`,
  1 AS `follower_name`,
  1 AS `start_date`,
  1 AS `end_date`,
  1 AS `pay_deadline`,
  1 AS `warning_days`,
  1 AS `decoration_days`,
  1 AS `is_decoration_free`,
  1 AS `annex`,
  1 AS `settle_park`,
  1 AS `settle_park_name`,
  1 AS `contract_id`,
  1 AS `contract_name`,
  1 AS `dept_id`,
  1 AS `is_pushed`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_lease_termination`
--

DROP TABLE IF EXISTS `dwd_lease_termination`;
/*!50001 DROP VIEW IF EXISTS `dwd_lease_termination`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_lease_termination` AS SELECT
 1 AS `id`,
  1 AS `contract_id`,
  1 AS `contract_id_label`,
  1 AS `customer_id`,
  1 AS `customer_id_label`,
  1 AS `code`,
  1 AS `start_date`,
  1 AS `end_date`,
  1 AS `reason`,
  1 AS `sign_by`,
  1 AS `sign_date`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `enterprise_key` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_meeting_room`
--

DROP TABLE IF EXISTS `dwd_meeting_room`;
/*!50001 DROP VIEW IF EXISTS `dwd_meeting_room`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_meeting_room` AS SELECT
 1 AS `id`,
  1 AS `room_name`,
  1 AS `scope_of_personal`,
  1 AS `scope_of_company`,
  1 AS `area_source`,
  1 AS `area_covered`,
  1 AS `maximum_capacity`,
  1 AS `contact`,
  1 AS `contact_number`,
  1 AS `location`,
  1 AS `introduction`,
  1 AS `main_figure`,
  1 AS `attach_id`,
  1 AS `cancel_deadline`,
  1 AS `cancel_deadline_unit`,
  1 AS `monthly_statement`,
  1 AS `reservation_in_advance`,
  1 AS `approval_process`,
  1 AS `day_off_status`,
  1 AS `length_of_time`,
  1 AS `time_unit`,
  1 AS `time_interval`,
  1 AS `unit_price`,
  1 AS `inner_unit_price`,
  1 AS `latitude_and_longitude`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_meter_class`
--

DROP TABLE IF EXISTS `dwd_meter_class`;
/*!50001 DROP VIEW IF EXISTS `dwd_meter_class`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_meter_class` AS SELECT
 1 AS `id`,
  1 AS `dict_label`,
  1 AS `dict_value`,
  1 AS `suite_id`,
  1 AS `suite_code`,
  1 AS `version`,
  1 AS `dict_name`,
  1 AS `tenant_id`,
  1 AS `dict_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_meter_info`
--

DROP TABLE IF EXISTS `dwd_meter_info`;
/*!50001 DROP VIEW IF EXISTS `dwd_meter_info`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_meter_info` AS SELECT
 1 AS `id`,
  1 AS `meter_code`,
  1 AS `meter_type`,
  1 AS `meter_name`,
  1 AS `meter_class_id`,
  1 AS `cust_id`,
  1 AS `meter_id`,
  1 AS `meter_file_id`,
  1 AS `room_code`,
  1 AS `room_id`,
  1 AS `path_names`,
  1 AS `building_id`,
  1 AS `built_area`,
  1 AS `month`,
  1 AS `last_meter_reading_time`,
  1 AS `meter_reading_time`,
  1 AS `last_reading`,
  1 AS `reading`,
  1 AS `last_usage`,
  1 AS `this_usage`,
  1 AS `last_apex_reading`,
  1 AS `apex_reading`,
  1 AS `last_peak_reading`,
  1 AS `peak_reading`,
  1 AS `last_flat_reading`,
  1 AS `flat_reading`,
  1 AS `last_valley_reading`,
  1 AS `valley_reading`,
  1 AS `last_apex_usage`,
  1 AS `apex_usage`,
  1 AS `last_peak_usage`,
  1 AS `peak_usage`,
  1 AS `last_flat_usage`,
  1 AS `flat_usage`,
  1 AS `last_valley_usage`,
  1 AS `valley_usage`,
  1 AS `chain`,
  1 AS `apex_chain`,
  1 AS `peak_chain`,
  1 AS `flat_chain`,
  1 AS `valley_chain`,
  1 AS `ranges`,
  1 AS `ratio`,
  1 AS `share_ratio`,
  1 AS `shared_type`,
  1 AS `loss`,
  1 AS `source`,
  1 AS `settlement_status`,
  1 AS `recheck_status`,
  1 AS `floor_id`,
  1 AS `area_id`,
  1 AS `operator`,
  1 AS `energy_task_id`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_month_car_refill`
--

DROP TABLE IF EXISTS `dwd_month_car_refill`;
/*!50001 DROP VIEW IF EXISTS `dwd_month_car_refill`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_month_car_refill` AS SELECT
 1 AS `source_id`,
  1 AS `car_num`,
  1 AS `unit_price`,
  1 AS `pay_money`,
  1 AS `pay_money_encryption`,
  1 AS `pay_source`,
  1 AS `month_day`,
  1 AS `area_name`,
  1 AS `start_time`,
  1 AS `end_time`,
  1 AS `pay_time`,
  1 AS `pay_water`,
  1 AS `park_id`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_time`,
  1 AS `update_by`,
  1 AS `is_deleted`,
  1 AS `STATUS`,
  1 AS `etl_update_time`,
  1 AS `etl_source` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_pai_finace_receipt`
--

DROP TABLE IF EXISTS `dwd_pai_finace_receipt`;
/*!50001 DROP VIEW IF EXISTS `dwd_pai_finace_receipt`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_pai_finace_receipt` AS SELECT
 1 AS `id`,
  1 AS `number`,
  1 AS `customer_id`,
  1 AS `actual_total`,
  1 AS `receipt_date`,
  1 AS `receipt_way`,
  1 AS `bank`,
  1 AS `voucher_no`,
  1 AS `type`,
  1 AS `customer_name`,
  1 AS `tran_type`,
  1 AS `request_id`,
  1 AS `channel`,
  1 AS `summary`,
  1 AS `operator`,
  1 AS `is_push`,
  1 AS `is_reverse`,
  1 AS `reverse_reason`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `deduct_total`,
  1 AS `cashier`,
  1 AS `status`,
  1 AS `beneficiary_bank`,
  1 AS `receiving_account`,
  1 AS `receipt_type`,
  1 AS `remark`,
  1 AS `is_refund`,
  1 AS `is_pushed`,
  1 AS `ent_id`,
  1 AS `is_deleted` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_pai_park_space_area`
--

DROP TABLE IF EXISTS `dwd_pai_park_space_area`;
/*!50001 DROP VIEW IF EXISTS `dwd_pai_park_space_area`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_pai_park_space_area` AS SELECT
 1 AS `id`,
  1 AS `area_name`,
  1 AS `area_covered`,
  1 AS `function_area`,
  1 AS `building_amount`,
  1 AS `room_amount`,
  1 AS `built_area`,
  1 AS `is_virtual`,
  1 AS `ent_id`,
  1 AS `sorting`,
  1 AS `park_id`,
  1 AS `tenant_id`,
  1 AS `is_deleted`,
  1 AS `STATUS`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `profile_id`,
  1 AS `profile_code` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_pai_park_space_building`
--

DROP TABLE IF EXISTS `dwd_pai_park_space_building`;
/*!50001 DROP VIEW IF EXISTS `dwd_pai_park_space_building`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_pai_park_space_building` AS SELECT
 1 AS `id`,
  1 AS `park_id`,
  1 AS `building_code`,
  1 AS `building_name`,
  1 AS `area_id`,
  1 AS `floor_number`,
  1 AS `area_covered`,
  1 AS `built_area`,
  1 AS `property_right`,
  1 AS `property_right_desc`,
  1 AS `building_safety`,
  1 AS `image`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `underground`,
  1 AS `ent_id`,
  1 AS `sorting`,
  1 AS `tenant_id`,
  1 AS `profile_id`,
  1 AS `profile_code`,
  1 AS `share_area`,
  1 AS `lease_method`,
  1 AS `certificate` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_pai_park_space_floor`
--

DROP TABLE IF EXISTS `dwd_pai_park_space_floor`;
/*!50001 DROP VIEW IF EXISTS `dwd_pai_park_space_floor`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_pai_park_space_floor` AS SELECT
 1 AS `id`,
  1 AS `park_id`,
  1 AS `serial_code`,
  1 AS `floor_name`,
  1 AS `coefficient`,
  1 AS `building_id`,
  1 AS `tenant_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `floor_category`,
  1 AS `ent_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_pai_security_emergency`
--

DROP TABLE IF EXISTS `dwd_pai_security_emergency`;
/*!50001 DROP VIEW IF EXISTS `dwd_pai_security_emergency`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_pai_security_emergency` AS SELECT
 1 AS `id`,
  1 AS `title`,
  1 AS `type_id`,
  1 AS `type_name`,
  1 AS `num`,
  1 AS `warning_source`,
  1 AS `area`,
  1 AS `result`,
  1 AS `position`,
  1 AS `picture_id`,
  1 AS `auditor`,
  1 AS `auditor_desc`,
  1 AS `desc_content`,
  1 AS `ent_id`,
  1 AS `patrol_task_id`,
  1 AS `level`,
  1 AS `level_desc`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `status_desc`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_pai_security_patrol`
--

DROP TABLE IF EXISTS `dwd_pai_security_patrol`;
/*!50001 DROP VIEW IF EXISTS `dwd_pai_security_patrol`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_pai_security_patrol` AS SELECT
 1 AS `id`,
  1 AS `name`,
  1 AS `model`,
  1 AS `num`,
  1 AS `type`,
  1 AS `ent_id`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_pai_security_patrol_detail_sub`
--

DROP TABLE IF EXISTS `dwd_pai_security_patrol_detail_sub`;
/*!50001 DROP VIEW IF EXISTS `dwd_pai_security_patrol_detail_sub`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_pai_security_patrol_detail_sub` AS SELECT
 1 AS `id`,
  1 AS `task_id`,
  1 AS `point_id`,
  1 AS `point_sort`,
  1 AS `clock_time`,
  1 AS `clock_sort`,
  1 AS `ent_id`,
  1 AS `latitude`,
  1 AS `longitude`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_pai_security_patrol_task`
--

DROP TABLE IF EXISTS `dwd_pai_security_patrol_task`;
/*!50001 DROP VIEW IF EXISTS `dwd_pai_security_patrol_task`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_pai_security_patrol_task` AS SELECT
 1 AS `id`,
  1 AS `plan_id`,
  1 AS `duty_date`,
  1 AS `person_id`,
  1 AS `person`,
  1 AS `patrol_id`,
  1 AS `start_time`,
  1 AS `end_time`,
  1 AS `ent_id`,
  1 AS `line_id`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `status_desc`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_park`
--

DROP TABLE IF EXISTS `dwd_park`;
/*!50001 DROP VIEW IF EXISTS `dwd_park`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_park` AS SELECT
 1 AS `park_id`,
  1 AS `park_code`,
  1 AS `park_ent_id`,
  1 AS `park_domain`,
  1 AS `park_type`,
  1 AS `park_scale`,
  1 AS `park_area`,
  1 AS `park_floor_area`,
  1 AS `park_phone`,
  1 AS `park_address`,
  1 AS `park_status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `remark`,
  1 AS `park_name`,
  1 AS `park_logo`,
  1 AS `park_province`,
  1 AS `park_city`,
  1 AS `park_region`,
  1 AS `area_code`,
  1 AS `virtual_type`,
  1 AS `contact_person`,
  1 AS `contact_number`,
  1 AS `group_preset_id`,
  1 AS `group_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_park_space_room`
--

DROP TABLE IF EXISTS `dwd_park_space_room`;
/*!50001 DROP VIEW IF EXISTS `dwd_park_space_room`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_park_space_room` AS SELECT
 1 AS `id`,
  1 AS `park_id`,
  1 AS `renting_selling`,
  1 AS `renting_selling_desc`,
  1 AS `room_code`,
  1 AS `room_name`,
  1 AS `area_covered`,
  1 AS `built_area`,
  1 AS `house_structure`,
  1 AS `kit_id`,
  1 AS `purpose`,
  1 AS `room_describe`,
  1 AS `floor_id`,
  1 AS `image`,
  1 AS `is_order`,
  1 AS `tenant_id`,
  1 AS `is_lock`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `room_status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `purpose_id`,
  1 AS `floor_name`,
  1 AS `building_id`,
  1 AS `building_code`,
  1 AS `building_name`,
  1 AS `area_id`,
  1 AS `area_name` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_park_space_room_purpose`
--

DROP TABLE IF EXISTS `dwd_park_space_room_purpose`;
/*!50001 DROP VIEW IF EXISTS `dwd_park_space_room_purpose`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_park_space_room_purpose` AS SELECT
 1 AS `id`,
  1 AS `dict_label`,
  1 AS `dict_value`,
  1 AS `suite_id`,
  1 AS `suite_code`,
  1 AS `version`,
  1 AS `dict_name`,
  1 AS `tenant_id`,
  1 AS `dict_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_patrol_line_point`
--

DROP TABLE IF EXISTS `dwd_patrol_line_point`;
/*!50001 DROP VIEW IF EXISTS `dwd_patrol_line_point`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_patrol_line_point` AS SELECT
 1 AS `id`,
  1 AS `pid`,
  1 AS `sort`,
  1 AS `patrol_point_id`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `ent_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_patrol_task_dispatch_sub`
--

DROP TABLE IF EXISTS `dwd_patrol_task_dispatch_sub`;
/*!50001 DROP VIEW IF EXISTS `dwd_patrol_task_dispatch_sub`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_patrol_task_dispatch_sub` AS SELECT
 1 AS `id`,
  1 AS `task_id`,
  1 AS `person_id`,
  1 AS `dispatch_person_id`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `ent_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_prepaid`
--

DROP TABLE IF EXISTS `dwd_prepaid`;
/*!50001 DROP VIEW IF EXISTS `dwd_prepaid`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_prepaid` AS SELECT
 1 AS `id`,
  1 AS `customer_id`,
  1 AS `customer_name`,
  1 AS `total`,
  1 AS `unassigned_total`,
  1 AS `assigned_total`,
  1 AS `unassigned_balance`,
  1 AS `assigned_balance`,
  1 AS `total_balance`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `status_desc`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_property_contract_building`
--

DROP TABLE IF EXISTS `dwd_property_contract_building`;
/*!50001 DROP VIEW IF EXISTS `dwd_property_contract_building`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_property_contract_building` AS SELECT
 1 AS `id`,
  1 AS `floor_coefficient`,
  1 AS `contract_id`,
  1 AS `building_level`,
  1 AS `building_id`,
  1 AS `building_label`,
  1 AS `room_ids`,
  1 AS `building_code`,
  1 AS `change_type`,
  1 AS `rental_area`,
  1 AS `per_contract_id`,
  1 AS `per_contract_name`,
  1 AS `customer_id`,
  1 AS `customer_id_label`,
  1 AS `name`,
  1 AS `code`,
  1 AS `first_code`,
  1 AS `person`,
  1 AS `phone`,
  1 AS `payee_id`,
  1 AS `payee_id_label`,
  1 AS `annex`,
  1 AS `source_type`,
  1 AS `source_id`,
  1 AS `sign_by`,
  1 AS `sign_date`,
  1 AS `renewal_date`,
  1 AS `is_locked`,
  1 AS `per_contract_type`,
  1 AS `closing_date`,
  1 AS `effective_date`,
  1 AS `email`,
  1 AS `operated_type`,
  1 AS `dept_id`,
  1 AS `lease_change_id`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `status`,
  1 AS `status_desc`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_purchase_intention`
--

DROP TABLE IF EXISTS `dwd_purchase_intention`;
/*!50001 DROP VIEW IF EXISTS `dwd_purchase_intention`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_purchase_intention` AS SELECT
 1 AS `id`,
  1 AS `enterprise_id`,
  1 AS `enterprise_name`,
  1 AS `concat_person`,
  1 AS `concat_phone`,
  1 AS `source_id`,
  1 AS `area`,
  1 AS `unit_price`,
  1 AS `total_price`,
  1 AS `estimate_value`,
  1 AS `estimate_into_time`,
  1 AS `other_focus`,
  1 AS `dept_id`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_pushed`,
  1 AS `config_id`,
  1 AS `tags`,
  1 AS `park_name`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_by_name`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_purchase_intention_focus`
--

DROP TABLE IF EXISTS `dwd_purchase_intention_focus`;
/*!50001 DROP VIEW IF EXISTS `dwd_purchase_intention_focus`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_purchase_intention_focus` AS SELECT
 1 AS `id`,
  1 AS `intention_id`,
  1 AS `focus_id`,
  1 AS `focus_name`,
  1 AS `focus_items`,
  1 AS `focus_item_names`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_purchase_subscribe`
--

DROP TABLE IF EXISTS `dwd_purchase_subscribe`;
/*!50001 DROP VIEW IF EXISTS `dwd_purchase_subscribe`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_purchase_subscribe` AS SELECT
 1 AS `id`,
  1 AS `name`,
  1 AS `enterprise_id`,
  1 AS `enterprise_name`,
  1 AS `subscribe_date`,
  1 AS `contracts_num`,
  1 AS `follower`,
  1 AS `follower_name`,
  1 AS `attachment`,
  1 AS `settle_park`,
  1 AS `settle_park_name`,
  1 AS `contract_id`,
  1 AS `contract_name`,
  1 AS `dept_id`,
  1 AS `is_pushed`,
  1 AS `payee_id`,
  1 AS `payee_name`,
  1 AS `contact_name`,
  1 AS `contact_phone`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_purchase_subscribe_room`
--

DROP TABLE IF EXISTS `dwd_purchase_subscribe_room`;
/*!50001 DROP VIEW IF EXISTS `dwd_purchase_subscribe_room`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_purchase_subscribe_room` AS SELECT
 1 AS `id`,
  1 AS `room_id`,
  1 AS `room_name`,
  1 AS `path`,
  1 AS `area_covered`,
  1 AS `build_area`,
  1 AS `unit_price`,
  1 AS `total_price`,
  1 AS `billable_area`,
  1 AS `name`,
  1 AS `enterprise_id`,
  1 AS `enterprise_name`,
  1 AS `subscribe_date`,
  1 AS `contracts_num`,
  1 AS `follower`,
  1 AS `follower_name`,
  1 AS `attachment`,
  1 AS `settle_park`,
  1 AS `settle_park_name`,
  1 AS `contract_id`,
  1 AS `contract_name`,
  1 AS `dept_id`,
  1 AS `is_pushed`,
  1 AS `payee_id`,
  1 AS `payee_name`,
  1 AS `contact_name`,
  1 AS `contact_phone`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_receivable_items`
--

DROP TABLE IF EXISTS `dwd_receivable_items`;
/*!50001 DROP VIEW IF EXISTS `dwd_receivable_items`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_receivable_items` AS SELECT
 1 AS `bill_date`,
  1 AS `id`,
  1 AS `receivable_id`,
  1 AS `room_id`,
  1 AS `fee_item_id`,
  1 AS `start_date`,
  1 AS `end_date`,
  1 AS `receivable_amount`,
  1 AS `adjust_amount`,
  1 AS `total_amount`,
  1 AS `received_amount`,
  1 AS `late_fee`,
  1 AS `customer_id`,
  1 AS `tenant_id`,
  1 AS `room_path`,
  1 AS `park_id`,
  1 AS `payee_id`,
  1 AS `status`,
  1 AS `customer_name`,
  1 AS `fee_name`,
  1 AS `payee_name`,
  1 AS `late_fee_date`,
  1 AS `source_type`,
  1 AS `bill_month`,
  1 AS `contract_id`,
  1 AS `discount`,
  1 AS `rent_free`,
  1 AS `message_status`,
  1 AS `late_fee_received`,
  1 AS `unit_price`,
  1 AS `area`,
  1 AS `usage_amount`,
  1 AS `credit_date`,
  1 AS `credit_period`,
  1 AS `fee_type`,
  1 AS `last_fee_date`,
  1 AS `create_by`,
  1 AS `is_deleted`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_room`
--

DROP TABLE IF EXISTS `dwd_room`;
/*!50001 DROP VIEW IF EXISTS `dwd_room`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_room` AS SELECT
 1 AS `id`,
  1 AS `park_id`,
  1 AS `renting_selling`,
  1 AS `renting_selling_desc`,
  1 AS `room_code`,
  1 AS `room_name`,
  1 AS `area_covered`,
  1 AS `built_area`,
  1 AS `house_structure`,
  1 AS `kit_id`,
  1 AS `purpose`,
  1 AS `room_describe`,
  1 AS `floor_id`,
  1 AS `image`,
  1 AS `is_order`,
  1 AS `tenant_id`,
  1 AS `is_lock`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `room_status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `purpose_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_sale_contract`
--

DROP TABLE IF EXISTS `dwd_sale_contract`;
/*!50001 DROP VIEW IF EXISTS `dwd_sale_contract`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_sale_contract` AS SELECT
 1 AS `id`,
  1 AS `associate_id`,
  1 AS `name`,
  1 AS `code`,
  1 AS `customer_id`,
  1 AS `customer_id_label`,
  1 AS `copy_count`,
  1 AS `sign_dept_id`,
  1 AS `sign_by`,
  1 AS `sign_date`,
  1 AS `annex`,
  1 AS `charge_area`,
  1 AS `total_price`,
  1 AS `status`,
  1 AS `reason`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_sale_contract_room`
--

DROP TABLE IF EXISTS `dwd_sale_contract_room`;
/*!50001 DROP VIEW IF EXISTS `dwd_sale_contract_room`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_sale_contract_room` AS SELECT
 1 AS `sale_contract_id`,
  1 AS `building_id`,
  1 AS `building_id_label`,
  1 AS `path_name`,
  1 AS `price`,
  1 AS `total_price`,
  1 AS `area`,
  1 AS `inside_area`,
  1 AS `building_code`,
  1 AS `associate_id`,
  1 AS `name`,
  1 AS `code`,
  1 AS `customer_id`,
  1 AS `customer_id_label`,
  1 AS `copy_count`,
  1 AS `sign_dept_id`,
  1 AS `sign_by`,
  1 AS `sign_date`,
  1 AS `annex`,
  1 AS `charge_area`,
  1 AS `status`,
  1 AS `reason`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_stadium`
--

DROP TABLE IF EXISTS `dwd_stadium`;
/*!50001 DROP VIEW IF EXISTS `dwd_stadium`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_stadium` AS SELECT
 1 AS `id`,
  1 AS `stadium_name`,
  1 AS `area_source`,
  1 AS `scope_of_personal`,
  1 AS `type`,
  1 AS `area`,
  1 AS `contact`,
  1 AS `phone`,
  1 AS `maximum`,
  1 AS `stadium_num`,
  1 AS `rule_id`,
  1 AS `address`,
  1 AS `description`,
  1 AS `attach_id`,
  1 AS `book_days`,
  1 AS `enable_week`,
  1 AS `scope_of_company`,
  1 AS `day_off_status`,
  1 AS `main_figure`,
  1 AS `latitude_and_longitude`,
  1 AS `discount`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_sys_dept`
--

DROP TABLE IF EXISTS `dwd_sys_dept`;
/*!50001 DROP VIEW IF EXISTS `dwd_sys_dept`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_sys_dept` AS SELECT
 1 AS `dept_id`,
  1 AS `parent_id`,
  1 AS `ancestors`,
  1 AS `dept_name`,
  1 AS `order_num`,
  1 AS `leader`,
  1 AS `phone`,
  1 AS `email`,
  1 AS `status`,
  1 AS `status_desc`,
  1 AS `del_flag`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_temp_car_refill`
--

DROP TABLE IF EXISTS `dwd_temp_car_refill`;
/*!50001 DROP VIEW IF EXISTS `dwd_temp_car_refill`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_temp_car_refill` AS SELECT
 1 AS `id`,
  1 AS `car_num`,
  1 AS `order_id`,
  1 AS `unit_price`,
  1 AS `pay_money`,
  1 AS `pay_money_encryption`,
  1 AS `pay_source`,
  1 AS `start_time`,
  1 AS `end_time`,
  1 AS `pay_time`,
  1 AS `pay_water`,
  1 AS `time_long`,
  1 AS `synchronization`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_work_order`
--

DROP TABLE IF EXISTS `dwd_work_order`;
/*!50001 DROP VIEW IF EXISTS `dwd_work_order`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_work_order` AS SELECT
 1 AS `id`,
  1 AS `name`,
  1 AS `order_key`,
  1 AS `structure`,
  1 AS `type_id`,
  1 AS `config_id`,
  1 AS `description`,
  1 AS `working_hours`,
  1 AS `form_link`,
  1 AS `app_form_link`,
  1 AS `is_release`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `ent_id`,
  1 AS `is_init` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_work_order_evaluate`
--

DROP TABLE IF EXISTS `dwd_work_order_evaluate`;
/*!50001 DROP VIEW IF EXISTS `dwd_work_order_evaluate`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_work_order_evaluate` AS SELECT
 1 AS `id`,
  1 AS `instance_id`,
  1 AS `verify_evaluation`,
  1 AS `verify_score`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `ent_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_work_order_instance`
--

DROP TABLE IF EXISTS `dwd_work_order_instance`;
/*!50001 DROP VIEW IF EXISTS `dwd_work_order_instance`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_work_order_instance` AS SELECT
 1 AS `id`,
  1 AS `serial_id`,
  1 AS `title`,
  1 AS `priority`,
  1 AS `order_id`,
  1 AS `biz_id`,
  1 AS `form_link`,
  1 AS `app_form_link`,
  1 AS `pending_state`,
  1 AS `parent_id`,
  1 AS `is_parent`,
  1 AS `flow_id`,
  1 AS `receive_timeout_status`,
  1 AS `order_timeout_status`,
  1 AS `receive_notice`,
  1 AS `order_notice`,
  1 AS `receive_notice_status`,
  1 AS `order_notice_status`,
  1 AS `enterprise`,
  1 AS `is_close`,
  1 AS `is_reject`,
  1 AS `is_revocation`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `status_desc`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `ent_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_work_order_time_consume`
--

DROP TABLE IF EXISTS `dwd_work_order_time_consume`;
/*!50001 DROP VIEW IF EXISTS `dwd_work_order_time_consume`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_work_order_time_consume` AS SELECT
 1 AS `id`,
  1 AS `history_id`,
  1 AS `instance_id`,
  1 AS `start_time`,
  1 AS `end_time`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `ent_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwd_work_order_type`
--

DROP TABLE IF EXISTS `dwd_work_order_type`;
/*!50001 DROP VIEW IF EXISTS `dwd_work_order_type`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwd_work_order_type` AS SELECT
 1 AS `id`,
  1 AS `name`,
  1 AS `description`,
  1 AS `tenant_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `ent_id`,
  1 AS `is_init` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dws_meter_info_by_m`
--

DROP TABLE IF EXISTS `dws_meter_info_by_m`;
/*!50001 DROP VIEW IF EXISTS `dws_meter_info_by_m`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dws_meter_info_by_m` AS SELECT
 1 AS `meter_class_name`,
  1 AS `park_id`,
  1 AS `tenant_id`,
  1 AS `year_key`,
  1 AS `month_key`,
  1 AS `this_usage`,
  1 AS `date_key` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dws_meter_info_by_y`
--

DROP TABLE IF EXISTS `dws_meter_info_by_y`;
/*!50001 DROP VIEW IF EXISTS `dws_meter_info_by_y`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dws_meter_info_by_y` AS SELECT
 1 AS `meter_class_name`,
  1 AS `park_id`,
  1 AS `tenant_id`,
  1 AS `year_key`,
  1 AS `this_usage`,
  1 AS `date_key` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwt_car_free_manage`
--

DROP TABLE IF EXISTS `dwt_car_free_manage`;
/*!50001 DROP VIEW IF EXISTS `dwt_car_free_manage`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwt_car_free_manage` AS SELECT
 1 AS `source_id`,
  1 AS `car_num`,
  1 AS `car_contacts`,
  1 AS `user_id`,
  1 AS `car_phone`,
  1 AS `company_name`,
  1 AS `company_id`,
  1 AS `free_time_encryption`,
  1 AS `free_time`,
  1 AS `synchronization`,
  1 AS `car_unique_id`,
  1 AS `park_id`,
  1 AS `is_renew`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_time`,
  1 AS `update_by`,
  1 AS `is_deleted`,
  1 AS `status` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwt_car_in_record`
--

DROP TABLE IF EXISTS `dwt_car_in_record`;
/*!50001 DROP VIEW IF EXISTS `dwt_car_in_record`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwt_car_in_record` AS SELECT
 1 AS `id`,
  1 AS `car_num`,
  1 AS `record_id`,
  1 AS `enter_area`,
  1 AS `enter_time`,
  1 AS `park_id`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_time`,
  1 AS `update_by`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `is_black`,
  1 AS `is_free`,
  1 AS `month_car` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwt_cons_enterprise`
--

DROP TABLE IF EXISTS `dwt_cons_enterprise`;
/*!50001 DROP VIEW IF EXISTS `dwt_cons_enterprise`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwt_cons_enterprise` AS SELECT
 1 AS `ent_id`,
  1 AS `ent_name`,
  1 AS `ent_code`,
  1 AS `ent_us_id`,
  1 AS `ent_domain`,
  1 AS `ent_trade`,
  1 AS `ent_scale`,
  1 AS `ent_person_phone`,
  1 AS `ent_person`,
  1 AS `ent_email`,
  1 AS `ent_tel`,
  1 AS `ent_fax`,
  1 AS `ent_address`,
  1 AS `ent_status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `remark`,
  1 AS `ent_logo`,
  1 AS `ent_type`,
  1 AS `ent_park_id`,
  1 AS `admin_name`,
  1 AS `admin_phone`,
  1 AS `virtual_type`,
  1 AS `group_preset_id`,
  1 AS `group_id`,
  1 AS `ent_class_id`,
  1 AS `source`,
  1 AS `source_name` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwt_enterprise`
--

DROP TABLE IF EXISTS `dwt_enterprise`;
/*!50001 DROP VIEW IF EXISTS `dwt_enterprise`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwt_enterprise` AS SELECT
 1 AS `enterprise_id`,
  1 AS `id`,
  1 AS `name`,
  1 AS `alias`,
  1 AS `history_names`,
  1 AS `eng_name`,
  1 AS `tax_number`,
  1 AS `credit_code`,
  1 AS `industry`,
  1 AS `estiblish_time`,
  1 AS `from_time`,
  1 AS `to_time`,
  1 AS `reg_status`,
  1 AS `is_micro_ent`,
  1 AS `org_number`,
  1 AS `category_big`,
  1 AS `legal_person_name`,
  1 AS `reg_capital`,
  1 AS `reg_location`,
  1 AS `origin_id`,
  1 AS `is_sync`,
  1 AS `ent_id`,
  1 AS `park_id`,
  1 AS `is_deleted`,
  1 AS `status`,
  1 AS `create_by`,
  1 AS `create_time`,
  1 AS `update_by`,
  1 AS `update_time`,
  1 AS `category`,
  1 AS `category_middle`,
  1 AS `category_small`,
  1 AS `history_name_list`,
  1 AS `staff_num_range`,
  1 AS `social_staff_num`,
  1 AS `business_scope`,
  1 AS `type`,
  1 AS `company_org_type`,
  1 AS `tags`,
  1 AS `percentile_score`,
  1 AS `base`,
  1 AS `city`,
  1 AS `district`,
  1 AS `reg_number`,
  1 AS `reg_capital_currency`,
  1 AS `actual_capital`,
  1 AS `actual_capital_currency`,
  1 AS `regInstitute`,
  1 AS `approved_time`,
  1 AS `bond_num`,
  1 AS `bond_name`,
  1 AS `used_bond_name`,
  1 AS `bond_type`,
  1 AS `revoke_date`,
  1 AS `revoke_reason`,
  1 AS `cancel_date`,
  1 AS `cancel_reason`,
  1 AS `logo`,
  1 AS `is_fill`,
  1 AS `tenant_id`,
  1 AS `reg_capital_level` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `dwt_parking_payment`
--

DROP TABLE IF EXISTS `dwt_parking_payment`;
/*!50001 DROP VIEW IF EXISTS `dwt_parking_payment`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `dwt_parking_payment` AS SELECT
 1 AS `park_id`,
  1 AS `pay_time`,
  1 AS `pay_money`,
  1 AS `last_year_money`,
  1 AS `car_num`,
  1 AS `pay_source`,
  1 AS `pay_type`,
  1 AS `area_name` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `temp_clue_source_channel`
--

DROP TABLE IF EXISTS `temp_clue_source_channel`;
/*!50001 DROP VIEW IF EXISTS `temp_clue_source_channel`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `temp_clue_source_channel` AS SELECT
 1 AS `id`,
  1 AS `dict_label`,
  1 AS `dict_value`,
  1 AS `suite_id`,
  1 AS `suite_code`,
  1 AS `version`,
  1 AS `dict_name`,
  1 AS `tenant_id`,
  1 AS `dict_id` */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `temp_room_purpose`
--

DROP TABLE IF EXISTS `temp_room_purpose`;
/*!50001 DROP VIEW IF EXISTS `temp_room_purpose`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE VIEW `temp_room_purpose` AS SELECT
 1 AS `id`,
  1 AS `dict_label`,
  1 AS `dict_value`,
  1 AS `suite_id`,
  1 AS `suite_code`,
  1 AS `version`,
  1 AS `dict_name`,
  1 AS `tenant_id`,
  1 AS `dict_id` */;
SET character_set_client = @saved_cs_client;

--
-- Dumping routines for database 'pai_screen_1782283103811162112'
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = 'ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION' */ ;
/*!50003 DROP PROCEDURE IF EXISTS `create_dim_date` */;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb4 */ ;
/*!50003 SET character_set_results = utf8mb4 */ ;
/*!50003 SET collation_connection  = utf8mb4_general_ci */ ;
DELIMITER ;;
CREATE DEFINER=`pai-screen-1782283103811162112`@`%` PROCEDURE `create_dim_date`(
	IN `start_date` DATETIME,
	IN `end_date` DATETIME
)
BEGIN
if start_date is null then  
	set start_date ='2018-01-01';
 end if;
if end_date is null then 
	set end_date = DATE_ADD(CURRENT_DATE(),INTERVAL 1 year) ;
end if ;


truncate table  dim_date;
WHILE start_date<=end_date DO 

	INSERT INTO dim_date (date_key) 
	VALUES (start_date); 
	SET start_date=date_add(start_date,INTERVAL 1 DAY); 
END WHILE;

update dim_date 
set year_key =year(date_key),
month_key = month(date_key),
year_name = CONCAT(year(date_key),'年'),
month_name = CONCAT(month(date_key),'月'), 
year_month_name =CONCAT(year(date_key),'年',month(date_key),'月');
END ;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Final view structure for view `ads_all_car_count`
--

/*!50001 DROP VIEW IF EXISTS `ads_all_car_count`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `ads_all_car_count` AS select `dwt_parking_payment`.`park_id` AS `park_id`,`dwt_parking_payment`.`car_num` AS `car_num` from `dwt_parking_payment` group by `dwt_parking_payment`.`park_id`,`dwt_parking_payment`.`car_num` union all select `dwt_car_free_manage`.`park_id` AS `park_id`,`dwt_car_free_manage`.`car_num` AS `car_num` from `dwt_car_free_manage` group by `dwt_car_free_manage`.`park_id`,`dwt_car_free_manage`.`car_num` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dim_month`
--

/*!50001 DROP VIEW IF EXISTS `dim_month`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dim_month` AS select `dim_date`.`year_key` AS `year_key`,`dim_date`.`month_key` AS `month_key`,min(`dim_date`.`date_key`) AS `start_date`,max(`dim_date`.`date_key`) AS `end_date` from `dim_date` group by `dim_date`.`year_key`,`dim_date`.`month_key` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dim_park`
--

/*!50001 DROP VIEW IF EXISTS `dim_park`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dim_park` AS select `pai_operate`.`cons_park`.`park_id` AS `park_id`,`pai_operate`.`cons_park`.`park_code` AS `park_code`,`pai_operate`.`cons_park`.`park_ent_id` AS `park_ent_id`,`pai_operate`.`cons_park`.`park_domain` AS `park_domain`,`pai_operate`.`cons_park`.`park_type` AS `park_type`,`pai_operate`.`cons_park`.`park_scale` AS `park_scale`,`pai_operate`.`cons_park`.`park_area` AS `park_area`,`pai_operate`.`cons_park`.`park_floor_area` AS `park_floor_area`,`pai_operate`.`cons_park`.`park_phone` AS `park_phone`,`pai_operate`.`cons_park`.`park_address` AS `park_address`,`pai_operate`.`cons_park`.`park_status` AS `park_status`,`pai_operate`.`cons_park`.`create_by` AS `create_by`,`pai_operate`.`cons_park`.`create_time` AS `create_time`,`pai_operate`.`cons_park`.`update_by` AS `update_by`,`pai_operate`.`cons_park`.`update_time` AS `update_time`,`pai_operate`.`cons_park`.`remark` AS `remark`,`pai_operate`.`cons_park`.`park_name` AS `park_name`,`pai_operate`.`cons_park`.`park_logo` AS `park_logo`,`pai_operate`.`cons_park`.`park_province` AS `park_province`,`pai_operate`.`cons_park`.`park_city` AS `park_city`,`pai_operate`.`cons_park`.`park_region` AS `park_region`,`pai_operate`.`cons_park`.`area_code` AS `area_code`,`pai_operate`.`cons_park`.`virtual_type` AS `virtual_type`,`pai_operate`.`cons_park`.`contact_person` AS `contact_person`,`pai_operate`.`cons_park`.`contact_number` AS `contact_number`,`b`.`group_preset_id` AS `group_preset_id`,`b`.`group_id` AS `group_id` from (`pai_operate`.`cons_park` join `pai_operate`.`cons_enterprise` `b` on((`pai_operate`.`cons_park`.`park_ent_id` = `b`.`ent_id`))) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dim_park_space_room`
--

/*!50001 DROP VIEW IF EXISTS `dim_park_space_room`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dim_park_space_room` AS select `m`.`id` AS `id`,`m`.`park_id` AS `park_id`,`m`.`renting_selling` AS `renting_selling`,(case `m`.`renting_selling` when 0 then '可租' when 1 then '可售' when 2 then '可租' when 3 then '自用' else `m`.`renting_selling` end) AS `renting_selling_desc`,`m`.`room_code` AS `room_code`,`m`.`room_name` AS `room_name`,`m`.`area_covered` AS `area_covered`,`m`.`built_area` AS `built_area`,`m`.`house_structure` AS `house_structure`,`m`.`kit_id` AS `kit_id`,`m`.`purpose` AS `purpose`,`m`.`room_describe` AS `room_describe`,`m`.`floor_id` AS `floor_id`,`m`.`image` AS `image`,`m`.`is_order` AS `is_order`,`m`.`tenant_id` AS `tenant_id`,`m`.`is_lock` AS `is_lock`,`m`.`is_deleted` AS `is_deleted`,`m`.`status` AS `status`,(case `m`.`status` when 0 then '空置' when 1 then '已租' when 2 then '已售' when 3 then '已售待租' when '4' then '已售已租' when 5 then '自用' when 6 then '已预定' else `m`.`status` end) AS `room_status`,`m`.`create_by` AS `create_by`,`m`.`create_time` AS `create_time`,`m`.`update_by` AS `update_by`,`m`.`update_time` AS `update_time`,`m`.`purpose_id` AS `purpose_id`,`f`.`floor_name` AS `floor_name`,`f`.`building_id` AS `building_id`,`b`.`building_code` AS `building_code`,`b`.`building_name` AS `building_name`,`b`.`area_id` AS `area_id`,`a`.`area_name` AS `area_name` from (((`pai_park_space`.`room` `m` join `pai_park_space`.`floor` `f` on((`m`.`floor_id` = `f`.`id`))) join `pai_park_space`.`building` `b` on((`f`.`building_id` = `b`.`id`))) left join `pai_park_space`.`area` `a` on((`b`.`area_id` = `a`.`id`))) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dim_year`
--

/*!50001 DROP VIEW IF EXISTS `dim_year`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dim_year` AS select `dim_date`.`year_key` AS `year_key`,min(`dim_date`.`date_key`) AS `start_date`,max(`dim_date`.`date_key`) AS `end_date` from `dim_date` group by `dim_date`.`year_key` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_area_setting`
--

/*!50001 DROP VIEW IF EXISTS `dwd_area_setting`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_area_setting` AS select `a`.`id` AS `source_id`,`a`.`area_name` AS `area_name`,`a`.`area_count` AS `area_count`,`a`.`area_num` AS `area_num`,`a`.`config_id` AS `config_id`,`a`.`month_id` AS `month_id`,`a`.`free_num` AS `free_num`,`a`.`park_id` AS `park_id`,`a`.`is_show` AS `is_show`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_time` AS `update_time`,`a`.`update_by` AS `update_by`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,concat(`a`.`park_id`,`a`.`id`) AS `area_key` from `pai_parking`.`area_setting` `a` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_business_plan_detail`
--

/*!50001 DROP VIEW IF EXISTS `dwd_business_plan_detail`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_business_plan_detail` AS select `a`.`id` AS `id`,`a`.`plan_id` AS `plan_id`,`a`.`indicator` AS `indicator`,`a`.`indicator_name` AS `indicator_name`,`a`.`indicator_val` AS `indicator_val`,`a`.`indicator_unit` AS `indicator_unit`,`a`.`executor` AS `executor`,`a`.`executor_name` AS `executor_name`,`a`.`remark` AS `remark`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status` from `pai_business`.`plan_detail` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_business_plan_plan`
--

/*!50001 DROP VIEW IF EXISTS `dwd_business_plan_plan`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_business_plan_plan` AS select `a`.`id` AS `id`,`a`.`dept` AS `dept`,`a`.`dept_name` AS `dept_name`,`a`.`year` AS `year`,`a`.`type` AS `type`,`a`.`type_name` AS `type_name`,`a`.`section` AS `section`,`a`.`section_name` AS `section_name`,`a`.`start` AS `start`,`a`.`end` AS `end`,`a`.`remark` AS `remark`,`a`.`contract_num` AS `contract_num`,`a`.`sale_amount` AS `sale_amount`,`a`.`lease_amount` AS `lease_amount`,`a`.`land_amount` AS `land_amount`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`park_name` AS `park_name`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_by_name` AS `create_by_name`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_business`.`plan` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_car_free_manage`
--

/*!50001 DROP VIEW IF EXISTS `dwd_car_free_manage`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_car_free_manage` AS select `a`.`id` AS `source_id`,`a`.`car_num` AS `car_num`,`a`.`car_contacts` AS `car_contacts`,`a`.`user_id` AS `user_id`,`a`.`car_phone` AS `car_phone`,`a`.`company_name` AS `company_name`,`a`.`company_id` AS `company_id`,`a`.`free_time_encryption` AS `free_time_encryption`,`a`.`free_time` AS `free_time`,`a`.`synchronization` AS `synchronization`,`a`.`car_unique_id` AS `car_unique_id`,`a`.`park_id` AS `park_id`,`a`.`is_renew` AS `is_renew`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_time` AS `update_time`,`a`.`update_by` AS `update_by`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status` from `pai_parking`.`car_free_manage` `a` where ((1 = 1) and (`a`.`is_deleted` = 0)) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_car_in_record`
--

/*!50001 DROP VIEW IF EXISTS `dwd_car_in_record`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_car_in_record` AS select `a`.`id` AS `id`,`a`.`car_num` AS `car_num`,`a`.`record_id` AS `record_id`,`a`.`enter_area` AS `enter_area`,`a`.`tenant_id` AS `tenant_id`,`a`.`enter_time` AS `enter_time`,`a`.`park_id` AS `park_id`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_time` AS `update_time`,`a`.`update_by` AS `update_by`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status` from `pai_parking`.`car_in_record` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_car_manage`
--

/*!50001 DROP VIEW IF EXISTS `dwd_car_manage`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_car_manage` AS select `a`.`id` AS `source_id`,`a`.`car_num` AS `car_num`,`a`.`car_unique_id` AS `car_unique_id`,`a`.`user_id` AS `user_id`,`a`.`area_id` AS `area_id`,`a`.`synchronization` AS `synchronization`,`a`.`remarks` AS `remarks`,`a`.`park_id` AS `park_id`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_time` AS `update_time`,`a`.`update_by` AS `update_by`,`a`.`is_free` AS `is_free`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`is_black` AS `is_black` from `pai_parking`.`car_manage` `a` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_cash_pledge`
--

/*!50001 DROP VIEW IF EXISTS `dwd_cash_pledge`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_cash_pledge` AS select `a`.`id` AS `id`,`a`.`code` AS `code`,`a`.`deposit_type` AS `deposit_type`,`a`.`customer_id` AS `customer_id`,`a`.`customer_name` AS `customer_name`,`a`.`contract_id` AS `contract_id`,`a`.`amount` AS `amount`,`a`.`pending` AS `pending`,`a`.`balance` AS `balance`,`a`.`type` AS `type`,(case `a`.`type` when 1 then '手动新增' when 2 then '自动生成' else `a`.`type` end) AS `type_desc`,`a`.`remark` AS `remark`,`a`.`payee_id` AS `payee_id`,`a`.`receipt_id` AS `receipt_id`,`a`.`contract_name` AS `contract_name`,`a`.`deposit_name` AS `deposit_name`,NULL AS `creditable_balance`,`a`.`receipt_request_id` AS `receipt_request_id`,`a`.`is_pushed` AS `is_pushed`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_finance`.`cash_pledge` `a` where ((1 = 1) and (`a`.`is_deleted` = 0)) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_clue_enterprise`
--

/*!50001 DROP VIEW IF EXISTS `dwd_clue_enterprise`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_clue_enterprise` AS select `a`.`id` AS `id`,`a`.`enterprise_id` AS `enterprise_id`,`a`.`name` AS `name`,`a`.`contact` AS `contact`,`a`.`phone` AS `phone`,`a`.`source` AS `source`,`a`.`follower` AS `follower`,`a`.`follower_name` AS `follower_name`,`a`.`follow_status` AS `follow_status`,(case `a`.`follow_status` when 0 then '未跟进' when 1 then '跟进中' else `a`.`follow_status` end) AS `follow_status_desc`,`a`.`tenant_id` AS `tenant_id`,`a`.`channel_id` AS `channel_id`,`a`.`channel_name` AS `channel_name`,`a`.`config_id` AS `config_id`,`a`.`tag` AS `tag`,`a`.`park_id` AS `park_id`,`a`.`park_name` AS `park_name`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time`,`a`.`dept_id` AS `dept_id`,`a`.`dept_name` AS `dept_name`,`a`.`ent_id` AS `ent_id` from `pai_business`.`clue_enterprise` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_clue_source_channel`
--

/*!50001 DROP VIEW IF EXISTS `dwd_clue_source_channel`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_clue_source_channel` AS select `a`.`id` AS `id`,(convert(`a`.`dict_label` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `dict_label`,(convert(`a`.`dict_value` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `dict_value`,`a`.`suite_id` AS `suite_id`,`a`.`suite_code` AS `suite_code`,`a`.`version` AS `version`,`a`.`dict_name` AS `dict_name`,(convert(`a`.`tenant_id` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `tenant_id`,`a`.`dict_id` AS `dict_id` from (`temp_clue_source_channel` `a` join (select max(`temp_clue_source_channel`.`version`) AS `version`,`temp_clue_source_channel`.`tenant_id` AS `tenant_id` from `temp_clue_source_channel` group by `temp_clue_source_channel`.`tenant_id`) `b` on(((`a`.`version` = `b`.`version`) and (ifnull(`a`.`tenant_id`,'') = ifnull(`b`.`tenant_id`,''))))) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_enterprise`
--

/*!50001 DROP VIEW IF EXISTS `dwd_enterprise`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_enterprise` AS select `pai_enterprise`.`enterprise`.`id` AS `enterprise_id`,`pai_enterprise`.`enterprise`.`id` AS `id`,`pai_enterprise`.`enterprise`.`name` AS `name`,`pai_enterprise`.`enterprise`.`alias` AS `alias`,`pai_enterprise`.`enterprise`.`history_names` AS `history_names`,`pai_enterprise`.`enterprise`.`eng_name` AS `eng_name`,`pai_enterprise`.`enterprise`.`tax_number` AS `tax_number`,`pai_enterprise`.`enterprise`.`credit_code` AS `credit_code`,`pai_enterprise`.`enterprise`.`industry` AS `industry`,`pai_enterprise`.`enterprise`.`estiblish_time` AS `estiblish_time`,`pai_enterprise`.`enterprise`.`from_time` AS `from_time`,`pai_enterprise`.`enterprise`.`to_time` AS `to_time`,`pai_enterprise`.`enterprise`.`reg_status` AS `reg_status`,`pai_enterprise`.`enterprise`.`is_micro_ent` AS `is_micro_ent`,`pai_enterprise`.`enterprise`.`org_number` AS `org_number`,`pai_enterprise`.`enterprise`.`category_big` AS `category_big`,`pai_enterprise`.`enterprise`.`legal_person_name` AS `legal_person_name`,`pai_enterprise`.`enterprise`.`reg_capital` AS `reg_capital`,`pai_enterprise`.`enterprise`.`reg_location` AS `reg_location`,`pai_enterprise`.`enterprise`.`origin_id` AS `origin_id`,`pai_enterprise`.`enterprise`.`is_sync` AS `is_sync`,`pai_enterprise`.`enterprise`.`ent_id` AS `ent_id`,`pai_enterprise`.`enterprise`.`park_id` AS `park_id`,`pai_enterprise`.`enterprise`.`is_deleted` AS `is_deleted`,`pai_enterprise`.`enterprise`.`status` AS `status`,`pai_enterprise`.`enterprise`.`create_by` AS `create_by`,`pai_enterprise`.`enterprise`.`create_time` AS `create_time`,`pai_enterprise`.`enterprise`.`update_by` AS `update_by`,`pai_enterprise`.`enterprise`.`update_time` AS `update_time`,`pai_enterprise`.`enterprise`.`category` AS `category`,`pai_enterprise`.`enterprise`.`category_middle` AS `category_middle`,`pai_enterprise`.`enterprise`.`category_small` AS `category_small`,`pai_enterprise`.`enterprise`.`history_name_list` AS `history_name_list`,`pai_enterprise`.`enterprise`.`staff_num_range` AS `staff_num_range`,`pai_enterprise`.`enterprise`.`social_staff_num` AS `social_staff_num`,`pai_enterprise`.`enterprise`.`business_scope` AS `business_scope`,`pai_enterprise`.`enterprise`.`type` AS `type`,`pai_enterprise`.`enterprise`.`company_org_type` AS `company_org_type`,`pai_enterprise`.`enterprise`.`tags` AS `tags`,`pai_enterprise`.`enterprise`.`percentile_score` AS `percentile_score`,`pai_enterprise`.`enterprise`.`base` AS `base`,`pai_enterprise`.`enterprise`.`city` AS `city`,`pai_enterprise`.`enterprise`.`district` AS `district`,`pai_enterprise`.`enterprise`.`reg_number` AS `reg_number`,`pai_enterprise`.`enterprise`.`reg_capital_currency` AS `reg_capital_currency`,`pai_enterprise`.`enterprise`.`actual_capital` AS `actual_capital`,`pai_enterprise`.`enterprise`.`actual_capital_currency` AS `actual_capital_currency`,`pai_enterprise`.`enterprise`.`regInstitute` AS `regInstitute`,`pai_enterprise`.`enterprise`.`approved_time` AS `approved_time`,`pai_enterprise`.`enterprise`.`bond_num` AS `bond_num`,`pai_enterprise`.`enterprise`.`bond_name` AS `bond_name`,`pai_enterprise`.`enterprise`.`used_bond_name` AS `used_bond_name`,`pai_enterprise`.`enterprise`.`bond_type` AS `bond_type`,`pai_enterprise`.`enterprise`.`revoke_date` AS `revoke_date`,`pai_enterprise`.`enterprise`.`revoke_reason` AS `revoke_reason`,`pai_enterprise`.`enterprise`.`cancel_date` AS `cancel_date`,`pai_enterprise`.`enterprise`.`cancel_reason` AS `cancel_reason`,`pai_enterprise`.`enterprise`.`logo` AS `logo`,`pai_enterprise`.`enterprise`.`is_fill` AS `is_fill`,`pai_enterprise`.`enterprise`.`tenant_id` AS `tenant_id` from `pai_enterprise`.`enterprise` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_enterprise_biz`
--

/*!50001 DROP VIEW IF EXISTS `dwd_enterprise_biz`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_enterprise_biz` AS select `a`.`id` AS `id`,`a`.`enterprise_id` AS `enterprise_id`,`a`.`enterprise_name` AS `enterprise_name`,`a`.`milestone` AS `milestone`,(case `a`.`milestone` when 0 then '意向' when 1 then '协议' when 2 then '合同' when 3 then '入驻' else `a`.`milestone` end) AS `milestone_desc`,`a`.`type` AS `type`,(case `a`.`type` when 1 then '租赁' when 2 then '销售' when 3 then '土地' else `a`.`type` end) AS `type_desc`,`a`.`biz_id` AS `biz_id`,`a`.`source` AS `source`,`a`.`name` AS `name`,`a`.`phone` AS `phone`,`a`.`dept_id` AS `dept_id`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`park_name` AS `park_name`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_by_name` AS `create_by_name`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from (`pai_business`.`enterprise_biz` `a` join (select `biz`.`enterprise_id` AS `enterprise_id`,`biz`.`park_id` AS `park_id`,`biz`.`tenant_id` AS `tenant_id`,max(`biz`.`milestone`) AS `milestone` from `pai_business`.`enterprise_biz` `biz` group by `biz`.`enterprise_id`,`biz`.`park_id`,`biz`.`tenant_id`) `b` on(((`a`.`enterprise_id` = `b`.`enterprise_id`) and (`a`.`park_id` = `b`.`park_id`) and (`a`.`tenant_id` = `a`.`tenant_id`)))) where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_enterprise_ent_bind`
--

/*!50001 DROP VIEW IF EXISTS `dwd_enterprise_ent_bind`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_enterprise_ent_bind` AS select `a`.`id` AS `id`,`a`.`enterprise_id` AS `enterprise_id`,`a`.`ent_id` AS `ent_id`,`a`.`phone` AS `phone`,`a`.`contact` AS `contact`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_enterprise`.`enterprise_ent_bind` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_fee_category`
--

/*!50001 DROP VIEW IF EXISTS `dwd_fee_category`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_fee_category` AS select `a`.`id` AS `id`,`a`.`category_name` AS `category_name`,`a`.`code` AS `code`,`a`.`parent_id` AS `parent_id`,`a`.`parent_code` AS `parent_code`,`a`.`level` AS `level`,`a`.`fee_type` AS `fee_type`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_finance`.`fee_category` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_fee_item`
--

/*!50001 DROP VIEW IF EXISTS `dwd_fee_item`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_fee_item` AS select `a`.`id` AS `id`,`a`.`name` AS `name`,`a`.`code` AS `code`,`a`.`category_id` AS `category_id`,`a`.`category_code` AS `category_code`,`a`.`fee_type` AS `fee_type`,`a`.`univalent` AS `univalent`,`a`.`late_fee_ratio` AS `late_fee_ratio`,`a`.`monthly_type` AS `monthly_type`,`a`.`fee_unit` AS `fee_unit`,`a`.`meter_class` AS `meter_class`,`a`.`meter_type` AS `meter_type`,`a`.`remark` AS `remark`,`a`.`payee_id` AS `payee_id`,`a`.`payee_name` AS `payee_name`,`a`.`is_sys` AS `is_sys`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_finance`.`fee_item` `a` where ((1 = 1) and (`a`.`is_deleted` = 0)) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_finance_intention`
--

/*!50001 DROP VIEW IF EXISTS `dwd_finance_intention`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_finance_intention` AS select `a`.`id` AS `id`,`a`.`code` AS `code`,`a`.`customer_id` AS `customer_id`,`a`.`customer_name` AS `customer_name`,`a`.`intention_id` AS `intention_id`,`a`.`intention_name` AS `intention_name`,`a`.`amount` AS `amount`,`a`.`received` AS `received`,`a`.`balance` AS `balance`,`a`.`payee_id` AS `payee_id`,`a`.`business_type` AS `business_type`,`a`.`receipt_request_id` AS `receipt_request_id`,`a`.`operational_balance` AS `operational_balance`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_finance`.`intention` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_lease_contract`
--

/*!50001 DROP VIEW IF EXISTS `dwd_lease_contract`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_lease_contract` AS select `a`.`id` AS `id`,`a`.`associate_id` AS `associate_id`,`a`.`customer_id` AS `customer_id`,`a`.`customer_id_label` AS `customer_id_label`,`a`.`name` AS `name`,`a`.`code` AS `code`,`a`.`first_code` AS `first_code`,`a`.`contact` AS `contact`,`a`.`phone` AS `phone`,`a`.`start_date` AS `start_date`,`a`.`end_date` AS `end_date`,`a`.`warning_days` AS `warning_days`,`a`.`decoration_days` AS `decoration_days`,`a`.`is_decoration_free` AS `is_decoration_free`,`a`.`is_have_property` AS `is_have_property`,`a`.`payee_id` AS `payee_id`,`a`.`payee_id_label` AS `payee_id_label`,`a`.`annex` AS `annex`,`a`.`source_type` AS `source_type`,`a`.`source_id` AS `source_id`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`dept_id` AS `dept_id`,`b`.`dept_name` AS `dept_desc`,`a`.`change_type` AS `change_type`,`a`.`effective_date` AS `effective_date`,`a`.`closing_date` AS `closing_date`,`a`.`email` AS `email`,`a`.`warn_status` AS `warn_status`,`a`.`biz_type` AS `biz_type`,(case `a`.`biz_type` when 1 then '智慧物业' when 2 then '招商租赁' else `a`.`biz_type` end) AS `biz_type_desc`,`a`.`is_reserve` AS `is_reserve`,`a`.`is_locked` AS `is_locked`,`a`.`status` AS `status`,(case `a`.`status` when 0 then '暂存' when 1 then '1审批中' when 2 then '未生效' when 3 then '生效中' when 4 then '已续签' when 5 then '已变更' when 6 then '已转租' when 7 then '已退租' when 8 then '已失效' else `a`.`status` end) AS `status_desc`,`a`.`sign_by` AS `sign_by`,`a`.`sign_date` AS `sign_date`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from (`pai_contract`.`lease_contract` `a` left join `dwd_sys_dept` `b` on((`a`.`dept_id` = `b`.`dept_id`))) where ((1 = 1) and (`a`.`status` > 1)) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_lease_contract_building`
--

/*!50001 DROP VIEW IF EXISTS `dwd_lease_contract_building`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_lease_contract_building` AS select `a`.`id` AS `id`,`a`.`contract_id` AS `contract_id`,`a`.`building_level` AS `building_level`,`a`.`building_id` AS `building_id`,`a`.`building_label` AS `building_label`,`a`.`rental_area` AS `rental_area`,`a`.`building_code` AS `building_code`,`a`.`change_type` AS `change_type`,`a`.`floor_coefficient` AS `floor_coefficient`,`b`.`associate_id` AS `associate_id`,`b`.`customer_id` AS `customer_id`,`b`.`customer_id_label` AS `customer_id_label`,`b`.`name` AS `name`,`b`.`code` AS `code`,`b`.`first_code` AS `first_code`,`b`.`contact` AS `contact`,`b`.`phone` AS `phone`,`b`.`start_date` AS `start_date`,`b`.`end_date` AS `end_date`,`b`.`warning_days` AS `warning_days`,`b`.`decoration_days` AS `decoration_days`,`b`.`is_decoration_free` AS `is_decoration_free`,`b`.`is_have_property` AS `is_have_property`,`b`.`payee_id` AS `payee_id`,`b`.`payee_id_label` AS `payee_id_label`,`b`.`annex` AS `annex`,`b`.`source_type` AS `source_type`,`b`.`source_id` AS `source_id`,`b`.`tenant_id` AS `tenant_id`,`b`.`park_id` AS `park_id`,`b`.`dept_id` AS `dept_id`,`b`.`effective_date` AS `effective_date`,`b`.`closing_date` AS `closing_date`,`b`.`email` AS `email`,`b`.`warn_status` AS `warn_status`,`b`.`biz_type` AS `biz_type`,`b`.`is_reserve` AS `is_reserve`,`b`.`is_locked` AS `is_locked`,`b`.`status` AS `status`,`b`.`sign_by` AS `sign_by`,`b`.`sign_date` AS `sign_date`,`b`.`create_by` AS `create_by`,`b`.`create_time` AS `create_time`,`b`.`update_by` AS `update_by`,`b`.`update_time` AS `update_time` from (`pai_contract`.`lease_contract_building` `a` join `pai_contract`.`lease_contract` `b` on((`a`.`contract_id` = `b`.`id`))) where (`b`.`status` > 1) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_lease_intention`
--

/*!50001 DROP VIEW IF EXISTS `dwd_lease_intention`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_lease_intention` AS select `a`.`id` AS `id`,`a`.`enterprise_id` AS `enterprise_id`,`a`.`enterprise_name` AS `enterprise_name`,`a`.`concat_person` AS `concat_person`,`a`.`concat_phone` AS `concat_phone`,`a`.`source_id` AS `source_id`,`a`.`estimate_into_time` AS `estimate_into_time`,`a`.`area` AS `area`,`a`.`price` AS `price`,`a`.`price_unit` AS `price_unit`,`a`.`estimate_value` AS `estimate_value`,`a`.`other_focus` AS `other_focus`,`a`.`dept_id` AS `dept_id`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`park_name` AS `park_name`,`a`.`config_id` AS `config_id`,`a`.`tags` AS `tags`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_by_name` AS `create_by_name`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time`,`a`.`is_pushed` AS `is_pushed` from `pai_business`.`lease_intention` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_lease_intention_focus`
--

/*!50001 DROP VIEW IF EXISTS `dwd_lease_intention_focus`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_lease_intention_focus` AS select `a`.`id` AS `id`,`a`.`intention_id` AS `intention_id`,`a`.`focus_id` AS `focus_id`,`a`.`focus_name` AS `focus_name`,`a`.`focus_items` AS `focus_items`,`a`.`focus_item_names` AS `focus_item_names`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_business`.`lease_intention_focus` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_lease_subscribe`
--

/*!50001 DROP VIEW IF EXISTS `dwd_lease_subscribe`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_lease_subscribe` AS select `a`.`id` AS `id`,`a`.`name` AS `name`,`a`.`payee_id` AS `payee_id`,`a`.`payee_name` AS `payee_name`,`a`.`customer_id` AS `customer_id`,`a`.`customer_name` AS `customer_name`,`a`.`sign_date` AS `sign_date`,`a`.`follower` AS `follower`,`a`.`follower_name` AS `follower_name`,`a`.`start_date` AS `start_date`,`a`.`end_date` AS `end_date`,`a`.`pay_deadline` AS `pay_deadline`,`a`.`warning_days` AS `warning_days`,`a`.`decoration_days` AS `decoration_days`,`a`.`is_decoration_free` AS `is_decoration_free`,`a`.`annex` AS `annex`,`a`.`settle_park` AS `settle_park`,`a`.`settle_park_name` AS `settle_park_name`,`a`.`contract_id` AS `contract_id`,`a`.`contract_name` AS `contract_name`,`a`.`billable_area` AS `billable_area`,`a`.`total_price` AS `total_price`,`a`.`dept_id` AS `dept_id`,`a`.`is_pushed` AS `is_pushed`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_business`.`lease_subscribe` `a` where ((1 = 1) and (`a`.`is_deleted` = 0) and (`a`.`status` = 0)) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_lease_subscribe_room`
--

/*!50001 DROP VIEW IF EXISTS `dwd_lease_subscribe_room`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_lease_subscribe_room` AS select `a`.`id` AS `id`,`a`.`subscribe_id` AS `subscribe_id`,`a`.`room_id` AS `room_id`,`a`.`path` AS `path`,`a`.`room_name` AS `room_name`,`a`.`area_covered` AS `area_covered`,`a`.`build_area` AS `build_area`,`a`.`unit_price` AS `unit_price`,`a`.`total_price` AS `total_price`,`a`.`billable_area` AS `billable_area`,`b`.`name` AS `name`,`b`.`payee_id` AS `payee_id`,`b`.`payee_name` AS `payee_name`,`b`.`customer_id` AS `customer_id`,`b`.`customer_name` AS `customer_name`,`b`.`sign_date` AS `sign_date`,`b`.`follower` AS `follower`,`b`.`follower_name` AS `follower_name`,`b`.`start_date` AS `start_date`,`b`.`end_date` AS `end_date`,`b`.`pay_deadline` AS `pay_deadline`,`b`.`warning_days` AS `warning_days`,`b`.`decoration_days` AS `decoration_days`,`b`.`is_decoration_free` AS `is_decoration_free`,`b`.`annex` AS `annex`,`b`.`settle_park` AS `settle_park`,`b`.`settle_park_name` AS `settle_park_name`,`b`.`contract_id` AS `contract_id`,`b`.`contract_name` AS `contract_name`,`b`.`dept_id` AS `dept_id`,`b`.`is_pushed` AS `is_pushed`,`b`.`tenant_id` AS `tenant_id`,`b`.`park_id` AS `park_id`,`b`.`is_deleted` AS `is_deleted`,`b`.`status` AS `status`,`b`.`create_by` AS `create_by`,`b`.`create_time` AS `create_time`,`b`.`update_by` AS `update_by`,`b`.`update_time` AS `update_time` from (`pai_business`.`lease_subscribe_room` `a` join `pai_business`.`lease_subscribe` `b` on((`a`.`subscribe_id` = `b`.`id`))) where ((1 = 1) and (`b`.`status` = 0)) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_lease_termination`
--

/*!50001 DROP VIEW IF EXISTS `dwd_lease_termination`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_lease_termination` AS select `a`.`id` AS `id`,`a`.`contract_id` AS `contract_id`,`a`.`contract_id_label` AS `contract_id_label`,`a`.`customer_id` AS `customer_id`,`a`.`customer_id_label` AS `customer_id_label`,`a`.`code` AS `code`,`a`.`start_date` AS `start_date`,`a`.`end_date` AS `end_date`,`a`.`reason` AS `reason`,`a`.`sign_by` AS `sign_by`,`a`.`sign_date` AS `sign_date`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time`,concat(`a`.`park_id`,`a`.`customer_id`) AS `enterprise_key` from `pai_park_property`.`lease_termination` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_meeting_room`
--

/*!50001 DROP VIEW IF EXISTS `dwd_meeting_room`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_meeting_room` AS select `a`.`id` AS `id`,`a`.`room_name` AS `room_name`,`a`.`scope_of_personal` AS `scope_of_personal`,`a`.`scope_of_company` AS `scope_of_company`,`a`.`area_source` AS `area_source`,`a`.`area_covered` AS `area_covered`,`a`.`maximum_capacity` AS `maximum_capacity`,`a`.`contact` AS `contact`,`a`.`contact_number` AS `contact_number`,`a`.`location` AS `location`,`a`.`introduction` AS `introduction`,`a`.`main_figure` AS `main_figure`,`a`.`attach_id` AS `attach_id`,`a`.`cancel_deadline` AS `cancel_deadline`,`a`.`cancel_deadline_unit` AS `cancel_deadline_unit`,`a`.`monthly_statement` AS `monthly_statement`,`a`.`reservation_in_advance` AS `reservation_in_advance`,`a`.`approval_process` AS `approval_process`,`a`.`day_off_status` AS `day_off_status`,`a`.`length_of_time` AS `length_of_time`,`a`.`time_unit` AS `time_unit`,`a`.`time_interval` AS `time_interval`,`a`.`unit_price` AS `unit_price`,`a`.`inner_unit_price` AS `inner_unit_price`,`a`.`latitude_and_longitude` AS `latitude_and_longitude`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_service_center`.`meeting_room_info` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_meter_class`
--

/*!50001 DROP VIEW IF EXISTS `dwd_meter_class`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_meter_class` AS select `a`.`id` AS `id`,(convert(`a`.`dict_label` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `dict_label`,(convert(`a`.`dict_value` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `dict_value`,`b`.`suite_id` AS `suite_id`,`b`.`suite_code` AS `suite_code`,`b`.`version` AS `version`,`b`.`dict_name` AS `dict_name`,(convert(`b`.`tenant_id` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `tenant_id`,`a`.`dict_id` AS `dict_id` from (`pai_config`.`ext_dict_data` `a` left join `pai_config`.`ext_dict_type` `b` on((`a`.`dict_id` = `b`.`dict_id`))) where ((1 = 1) and (`b`.`dict_name` = '能源表种类') and (`b`.`suite_code` = 'cn.flyrise.park.property') and `b`.`version` in (select max(`pai_config`.`ext_dict_type`.`version`) AS `version` from `pai_config`.`ext_dict_type` where ((1 = 1) and (`pai_config`.`ext_dict_type`.`dict_name` = '能源表种类') and (`pai_config`.`ext_dict_type`.`suite_code` = 'cn.flyrise.park.property')))) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_meter_info`
--

/*!50001 DROP VIEW IF EXISTS `dwd_meter_info`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_meter_info` AS select `a`.`id` AS `id`,`a`.`meter_code` AS `meter_code`,`a`.`meter_type` AS `meter_type`,`a`.`meter_name` AS `meter_name`,`a`.`meter_class_id` AS `meter_class_id`,`a`.`cust_id` AS `cust_id`,`a`.`meter_id` AS `meter_id`,`a`.`meter_file_id` AS `meter_file_id`,`a`.`room_code` AS `room_code`,`a`.`room_id` AS `room_id`,`a`.`path_names` AS `path_names`,`a`.`building_id` AS `building_id`,`a`.`built_area` AS `built_area`,`a`.`month` AS `month`,`a`.`last_meter_reading_time` AS `last_meter_reading_time`,`a`.`meter_reading_time` AS `meter_reading_time`,`a`.`last_reading` AS `last_reading`,`a`.`reading` AS `reading`,`a`.`last_usage` AS `last_usage`,`a`.`this_usage` AS `this_usage`,`a`.`last_apex_reading` AS `last_apex_reading`,`a`.`apex_reading` AS `apex_reading`,`a`.`last_peak_reading` AS `last_peak_reading`,`a`.`peak_reading` AS `peak_reading`,`a`.`last_flat_reading` AS `last_flat_reading`,`a`.`flat_reading` AS `flat_reading`,`a`.`last_valley_reading` AS `last_valley_reading`,`a`.`valley_reading` AS `valley_reading`,`a`.`last_apex_usage` AS `last_apex_usage`,`a`.`apex_usage` AS `apex_usage`,`a`.`last_peak_usage` AS `last_peak_usage`,`a`.`peak_usage` AS `peak_usage`,`a`.`last_flat_usage` AS `last_flat_usage`,`a`.`flat_usage` AS `flat_usage`,`a`.`last_valley_usage` AS `last_valley_usage`,`a`.`valley_usage` AS `valley_usage`,`a`.`chain` AS `chain`,`a`.`apex_chain` AS `apex_chain`,`a`.`peak_chain` AS `peak_chain`,`a`.`flat_chain` AS `flat_chain`,`a`.`valley_chain` AS `valley_chain`,`a`.`ranges` AS `ranges`,`a`.`ratio` AS `ratio`,`a`.`share_ratio` AS `share_ratio`,`a`.`shared_type` AS `shared_type`,`a`.`loss` AS `loss`,`a`.`source` AS `source`,`a`.`settlement_status` AS `settlement_status`,`a`.`recheck_status` AS `recheck_status`,`a`.`floor_id` AS `floor_id`,`a`.`area_id` AS `area_id`,`a`.`operator` AS `operator`,`a`.`energy_task_id` AS `energy_task_id`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_park_property`.`meter_info` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_month_car_refill`
--

/*!50001 DROP VIEW IF EXISTS `dwd_month_car_refill`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_month_car_refill` AS select `pai_parking`.`month_car_refill`.`id` AS `source_id`,`pai_parking`.`month_car_refill`.`car_num` AS `car_num`,`pai_parking`.`month_car_refill`.`unit_price` AS `unit_price`,`pai_parking`.`month_car_refill`.`pay_money` AS `pay_money`,`pai_parking`.`month_car_refill`.`pay_money_encryption` AS `pay_money_encryption`,(case `pai_parking`.`month_car_refill`.`pay_source` when '1' then '支付宝' when '2' then '微信' when '3' then '园付通' else `pai_parking`.`month_car_refill`.`pay_source` end) AS `pay_source`,`pai_parking`.`month_car_refill`.`month_day` AS `month_day`,`pai_parking`.`month_car_refill`.`area_name` AS `area_name`,`pai_parking`.`month_car_refill`.`start_time` AS `start_time`,`pai_parking`.`month_car_refill`.`end_time` AS `end_time`,`pai_parking`.`month_car_refill`.`pay_time` AS `pay_time`,`pai_parking`.`month_car_refill`.`pay_water` AS `pay_water`,`pai_parking`.`month_car_refill`.`park_id` AS `park_id`,`pai_parking`.`month_car_refill`.`create_by` AS `create_by`,`pai_parking`.`month_car_refill`.`create_time` AS `create_time`,`pai_parking`.`month_car_refill`.`update_time` AS `update_time`,`pai_parking`.`month_car_refill`.`update_by` AS `update_by`,`pai_parking`.`month_car_refill`.`is_deleted` AS `is_deleted`,`pai_parking`.`month_car_refill`.`status` AS `STATUS`,now() AS `etl_update_time`,'ods_month_car_refill' AS `etl_source` from `pai_parking`.`month_car_refill` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_pai_finace_receipt`
--

/*!50001 DROP VIEW IF EXISTS `dwd_pai_finace_receipt`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_pai_finace_receipt` AS select `a`.`id` AS `id`,`a`.`number` AS `number`,`a`.`customer_id` AS `customer_id`,`a`.`actual_total` AS `actual_total`,`a`.`receipt_date` AS `receipt_date`,`a`.`receipt_way` AS `receipt_way`,`a`.`bank` AS `bank`,`a`.`voucher_no` AS `voucher_no`,`a`.`type` AS `type`,`a`.`customer_name` AS `customer_name`,`a`.`tran_type` AS `tran_type`,`a`.`request_id` AS `request_id`,`a`.`channel` AS `channel`,`a`.`summary` AS `summary`,`a`.`operator` AS `operator`,`a`.`is_push` AS `is_push`,`a`.`is_reverse` AS `is_reverse`,`a`.`reverse_reason` AS `reverse_reason`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time`,`a`.`deduct_total` AS `deduct_total`,`a`.`cashier` AS `cashier`,`a`.`status` AS `status`,`a`.`beneficiary_bank` AS `beneficiary_bank`,`a`.`receiving_account` AS `receiving_account`,`a`.`receipt_type` AS `receipt_type`,`a`.`remark` AS `remark`,`a`.`is_refund` AS `is_refund`,`a`.`is_pushed` AS `is_pushed`,`a`.`ent_id` AS `ent_id`,`a`.`is_deleted` AS `is_deleted` from `pai_finance`.`receipt` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_pai_park_space_area`
--

/*!50001 DROP VIEW IF EXISTS `dwd_pai_park_space_area`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_pai_park_space_area` AS select `pai_park_space`.`area`.`id` AS `id`,`pai_park_space`.`area`.`area_name` AS `area_name`,`pai_park_space`.`area`.`area_covered` AS `area_covered`,`pai_park_space`.`area`.`function_area` AS `function_area`,`pai_park_space`.`area`.`building_amount` AS `building_amount`,`pai_park_space`.`area`.`room_amount` AS `room_amount`,`pai_park_space`.`area`.`built_area` AS `built_area`,`pai_park_space`.`area`.`is_virtual` AS `is_virtual`,`pai_park_space`.`area`.`ent_id` AS `ent_id`,`pai_park_space`.`area`.`sorting` AS `sorting`,`pai_park_space`.`area`.`park_id` AS `park_id`,`pai_park_space`.`area`.`tenant_id` AS `tenant_id`,`pai_park_space`.`area`.`is_deleted` AS `is_deleted`,`pai_park_space`.`area`.`status` AS `STATUS`,`pai_park_space`.`area`.`create_by` AS `create_by`,`pai_park_space`.`area`.`create_time` AS `create_time`,`pai_park_space`.`area`.`update_by` AS `update_by`,`pai_park_space`.`area`.`update_time` AS `update_time`,NULL AS `profile_id`,NULL AS `profile_code` from `pai_park_space`.`area` where (`pai_park_space`.`area`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_pai_park_space_building`
--

/*!50001 DROP VIEW IF EXISTS `dwd_pai_park_space_building`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_pai_park_space_building` AS select `pai_park_space`.`building`.`id` AS `id`,`pai_park_space`.`building`.`park_id` AS `park_id`,`pai_park_space`.`building`.`building_code` AS `building_code`,`pai_park_space`.`building`.`building_name` AS `building_name`,`pai_park_space`.`building`.`area_id` AS `area_id`,`pai_park_space`.`building`.`floor_number` AS `floor_number`,`pai_park_space`.`building`.`area_covered` AS `area_covered`,`pai_park_space`.`building`.`built_area` AS `built_area`,`pai_park_space`.`building`.`property_right` AS `property_right`,(case `pai_park_space`.`building`.`property_right` when 1 then '国有' when 2 then '集体' when 3 then '私有' when 4 then '股份' else `pai_park_space`.`building`.`property_right` end) AS `property_right_desc`,`pai_park_space`.`building`.`building_safety` AS `building_safety`,`pai_park_space`.`building`.`image` AS `image`,`pai_park_space`.`building`.`is_deleted` AS `is_deleted`,`pai_park_space`.`building`.`status` AS `status`,`pai_park_space`.`building`.`create_by` AS `create_by`,`pai_park_space`.`building`.`create_time` AS `create_time`,`pai_park_space`.`building`.`update_by` AS `update_by`,`pai_park_space`.`building`.`update_time` AS `update_time`,`pai_park_space`.`building`.`underground` AS `underground`,`pai_park_space`.`building`.`ent_id` AS `ent_id`,`pai_park_space`.`building`.`sorting` AS `sorting`,`pai_park_space`.`building`.`tenant_id` AS `tenant_id`,NULL AS `profile_id`,NULL AS `profile_code`,`pai_park_space`.`building`.`share_area` AS `share_area`,`pai_park_space`.`building`.`lease_method` AS `lease_method`,`pai_park_space`.`building`.`certificate` AS `certificate` from `pai_park_space`.`building` where ((1 = 1) and (`pai_park_space`.`building`.`is_deleted` = 0)) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_pai_park_space_floor`
--

/*!50001 DROP VIEW IF EXISTS `dwd_pai_park_space_floor`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_pai_park_space_floor` AS select `a`.`id` AS `id`,`a`.`park_id` AS `park_id`,`a`.`serial_code` AS `serial_code`,`a`.`floor_name` AS `floor_name`,`a`.`coefficient` AS `coefficient`,`a`.`building_id` AS `building_id`,`a`.`tenant_id` AS `tenant_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time`,`a`.`floor_category` AS `floor_category`,`a`.`ent_id` AS `ent_id` from `pai_park_space`.`floor` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_pai_security_emergency`
--

/*!50001 DROP VIEW IF EXISTS `dwd_pai_security_emergency`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_pai_security_emergency` AS select `a`.`id` AS `id`,`a`.`title` AS `title`,`a`.`type_id` AS `type_id`,`b`.`name` AS `type_name`,`a`.`num` AS `num`,`a`.`warning_source` AS `warning_source`,`a`.`area` AS `area`,`a`.`result` AS `result`,`a`.`position` AS `position`,`a`.`picture_id` AS `picture_id`,`a`.`auditor` AS `auditor`,`c`.`staff_name` AS `auditor_desc`,`a`.`desc_content` AS `desc_content`,`a`.`ent_id` AS `ent_id`,`a`.`patrol_task_id` AS `patrol_task_id`,`a`.`level` AS `level`,if((`a`.`level` = 3),'严重',if((`a`.`level` = 2),'重要',if((`a`.`level` = 1),'普通',if((`a`.`level` = 0),'提示','未分类')))) AS `level_desc`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,if((`a`.`status` = 2),'已处理','待处理') AS `status_desc`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from ((`pai_security`.`emergency` `a` left join `pai_security`.`event_type` `b` on((`a`.`type_id` = `b`.`id`))) left join `pai_operate`.`cons_staff` `c` on((`a`.`auditor` = `c`.`staff_id`))) where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_pai_security_patrol`
--

/*!50001 DROP VIEW IF EXISTS `dwd_pai_security_patrol`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_pai_security_patrol` AS select `a`.`id` AS `id`,`a`.`name` AS `name`,`a`.`model` AS `model`,`a`.`num` AS `num`,`a`.`type` AS `type`,`a`.`ent_id` AS `ent_id`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_security`.`patrol` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_pai_security_patrol_detail_sub`
--

/*!50001 DROP VIEW IF EXISTS `dwd_pai_security_patrol_detail_sub`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_pai_security_patrol_detail_sub` AS select `pai_security`.`patrol_detail_sub`.`id` AS `id`,`pai_security`.`patrol_detail_sub`.`task_id` AS `task_id`,`pai_security`.`patrol_detail_sub`.`point_id` AS `point_id`,`pai_security`.`patrol_detail_sub`.`point_sort` AS `point_sort`,`pai_security`.`patrol_detail_sub`.`clock_time` AS `clock_time`,`pai_security`.`patrol_detail_sub`.`clock_sort` AS `clock_sort`,`pai_security`.`patrol_detail_sub`.`ent_id` AS `ent_id`,`pai_security`.`patrol_detail_sub`.`latitude` AS `latitude`,`pai_security`.`patrol_detail_sub`.`longitude` AS `longitude`,`pai_security`.`patrol_detail_sub`.`tenant_id` AS `tenant_id`,`pai_security`.`patrol_detail_sub`.`park_id` AS `park_id`,`pai_security`.`patrol_detail_sub`.`is_deleted` AS `is_deleted`,`pai_security`.`patrol_detail_sub`.`status` AS `status`,`pai_security`.`patrol_detail_sub`.`create_by` AS `create_by`,`pai_security`.`patrol_detail_sub`.`create_time` AS `create_time`,`pai_security`.`patrol_detail_sub`.`update_by` AS `update_by`,`pai_security`.`patrol_detail_sub`.`update_time` AS `update_time` from `pai_security`.`patrol_detail_sub` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_pai_security_patrol_task`
--

/*!50001 DROP VIEW IF EXISTS `dwd_pai_security_patrol_task`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_pai_security_patrol_task` AS select `a`.`id` AS `id`,`a`.`plan_id` AS `plan_id`,`a`.`duty_date` AS `duty_date`,`a`.`person_id` AS `person_id`,`b`.`staff_name` AS `person`,`a`.`patrol_id` AS `patrol_id`,`a`.`start_time` AS `start_time`,`a`.`end_time` AS `end_time`,`a`.`ent_id` AS `ent_id`,`a`.`line_id` AS `line_id`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,if((`a`.`status` = 0),'未开始',if((`a`.`status` = 1),'执行中',if((`a`.`status` = 2),'已完成',if((`a`.`status` = 3),'已完成 (超时)',if((`a`.`status` = 4),'已完成 (路线错误)',if((`a`.`status` = 5),'已完成 (路线错误-超时)',if((`a`.`status` = 6),'已完成（调度）',if((`a`.`status` = 7),'已完成（调度-超时',if((`a`.`status` = 8),'已完成（调度-路线错误）',if((`a`.`status` = 9),'已完成 （调度-路线错误-超时）',if((`a`.`status` = 10),'未完成 (漏打卡)',if((`a`.`status` = 11),'未开始 (已调度)',if((`a`.`status` = 12),'执行中 (已调度)',if((`a`.`status` = 13),'未完成 (已调度)',if((`a`.`status` = 14),'执行中 (调度-路线错误)',if((`a`.`status` = 15),'未开始 (待调度)',if((`a`.`status` = 16),'执行中 (路线错误)','未知状态'))))))))))))))))) AS `status_desc`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from (`pai_security`.`patrol_task` `a` left join `pai_operate`.`cons_staff` `b` on((`a`.`person_id` = `b`.`staff_id`))) where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_park`
--

/*!50001 DROP VIEW IF EXISTS `dwd_park`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_park` AS select `pai_operate`.`cons_park`.`park_id` AS `park_id`,`pai_operate`.`cons_park`.`park_code` AS `park_code`,`pai_operate`.`cons_park`.`park_ent_id` AS `park_ent_id`,`pai_operate`.`cons_park`.`park_domain` AS `park_domain`,`pai_operate`.`cons_park`.`park_type` AS `park_type`,`pai_operate`.`cons_park`.`park_scale` AS `park_scale`,`pai_operate`.`cons_park`.`park_area` AS `park_area`,`pai_operate`.`cons_park`.`park_floor_area` AS `park_floor_area`,`pai_operate`.`cons_park`.`park_phone` AS `park_phone`,`pai_operate`.`cons_park`.`park_address` AS `park_address`,`pai_operate`.`cons_park`.`park_status` AS `park_status`,`pai_operate`.`cons_park`.`create_by` AS `create_by`,`pai_operate`.`cons_park`.`create_time` AS `create_time`,`pai_operate`.`cons_park`.`update_by` AS `update_by`,`pai_operate`.`cons_park`.`update_time` AS `update_time`,`pai_operate`.`cons_park`.`remark` AS `remark`,`pai_operate`.`cons_park`.`park_name` AS `park_name`,`pai_operate`.`cons_park`.`park_logo` AS `park_logo`,`pai_operate`.`cons_park`.`park_province` AS `park_province`,`pai_operate`.`cons_park`.`park_city` AS `park_city`,`pai_operate`.`cons_park`.`park_region` AS `park_region`,`pai_operate`.`cons_park`.`area_code` AS `area_code`,`pai_operate`.`cons_park`.`virtual_type` AS `virtual_type`,`pai_operate`.`cons_park`.`contact_person` AS `contact_person`,`pai_operate`.`cons_park`.`contact_number` AS `contact_number`,`b`.`group_preset_id` AS `group_preset_id`,`b`.`group_id` AS `group_id` from (`pai_operate`.`cons_park` join `pai_operate`.`cons_enterprise` `b` on((`pai_operate`.`cons_park`.`park_ent_id` = `b`.`ent_id`))) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_park_space_room`
--

/*!50001 DROP VIEW IF EXISTS `dwd_park_space_room`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_park_space_room` AS select `m`.`id` AS `id`,`m`.`park_id` AS `park_id`,`m`.`renting_selling` AS `renting_selling`,(case `m`.`renting_selling` when 0 then '可租' when 1 then '可售' when 2 then '可租' when 3 then '自用' else `m`.`renting_selling` end) AS `renting_selling_desc`,`m`.`room_code` AS `room_code`,`m`.`room_name` AS `room_name`,`m`.`area_covered` AS `area_covered`,`m`.`built_area` AS `built_area`,`m`.`house_structure` AS `house_structure`,`m`.`kit_id` AS `kit_id`,`m`.`purpose` AS `purpose`,`m`.`room_describe` AS `room_describe`,`m`.`floor_id` AS `floor_id`,`m`.`image` AS `image`,`m`.`is_order` AS `is_order`,`m`.`tenant_id` AS `tenant_id`,`m`.`is_lock` AS `is_lock`,`m`.`is_deleted` AS `is_deleted`,`m`.`status` AS `status`,(case `m`.`status` when 0 then '空置' when 1 then '已租' when 2 then '已售' when 3 then '已售待租' when '4' then '已售已租' when 5 then '自用' when 6 then '已预定' else `m`.`status` end) AS `room_status`,`m`.`create_by` AS `create_by`,`m`.`create_time` AS `create_time`,`m`.`update_by` AS `update_by`,`m`.`update_time` AS `update_time`,`m`.`purpose_id` AS `purpose_id`,`f`.`floor_name` AS `floor_name`,`f`.`building_id` AS `building_id`,`b`.`building_code` AS `building_code`,`b`.`building_name` AS `building_name`,`b`.`area_id` AS `area_id`,`a`.`area_name` AS `area_name` from (((`pai_park_space`.`room` `m` join `pai_park_space`.`floor` `f` on((`m`.`floor_id` = `f`.`id`))) join `pai_park_space`.`building` `b` on((`f`.`building_id` = `b`.`id`))) left join `pai_park_space`.`area` `a` on((`b`.`area_id` = `a`.`id`))) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_park_space_room_purpose`
--

/*!50001 DROP VIEW IF EXISTS `dwd_park_space_room_purpose`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_park_space_room_purpose` AS select `a`.`id` AS `id`,(convert(`a`.`dict_label` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `dict_label`,(convert(`a`.`dict_value` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `dict_value`,`a`.`suite_id` AS `suite_id`,`a`.`suite_code` AS `suite_code`,`a`.`version` AS `version`,`a`.`dict_name` AS `dict_name`,(convert(`a`.`tenant_id` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `tenant_id`,`a`.`dict_id` AS `dict_id` from (`temp_room_purpose` `a` join (select max(`temp_room_purpose`.`version`) AS `version`,`temp_room_purpose`.`tenant_id` AS `tenant_id` from `temp_room_purpose` group by `temp_room_purpose`.`tenant_id`) `b` on(((`a`.`version` = `b`.`version`) and (ifnull(`a`.`tenant_id`,'') = ifnull(`b`.`tenant_id`,''))))) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_patrol_line_point`
--

/*!50001 DROP VIEW IF EXISTS `dwd_patrol_line_point`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_patrol_line_point` AS select `a`.`id` AS `id`,`a`.`pid` AS `pid`,`a`.`sort` AS `sort`,`a`.`patrol_point_id` AS `patrol_point_id`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time`,`a`.`ent_id` AS `ent_id` from `pai_security`.`patrol_line_point` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_patrol_task_dispatch_sub`
--

/*!50001 DROP VIEW IF EXISTS `dwd_patrol_task_dispatch_sub`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_patrol_task_dispatch_sub` AS select `a`.`id` AS `id`,`a`.`task_id` AS `task_id`,`a`.`person_id` AS `person_id`,`a`.`dispatch_person_id` AS `dispatch_person_id`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time`,`a`.`ent_id` AS `ent_id` from `pai_security`.`patrol_task_dispatch_sub` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_prepaid`
--

/*!50001 DROP VIEW IF EXISTS `dwd_prepaid`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_prepaid` AS select `a`.`id` AS `id`,`a`.`customer_id` AS `customer_id`,`a`.`customer_name` AS `customer_name`,`a`.`total` AS `total`,`a`.`unassigned_total` AS `unassigned_total`,`a`.`assigned_total` AS `assigned_total`,`a`.`unassigned_balance` AS `unassigned_balance`,`a`.`assigned_balance` AS `assigned_balance`,`a`.`total_balance` AS `total_balance`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,(case `a`.`status` when 0 then '未结清' when 1 then '已结清' else `a`.`status` end) AS `status_desc`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_finance`.`prepaid` `a` where ((1 = 1) and (`a`.`is_deleted` = 0)) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_property_contract_building`
--

/*!50001 DROP VIEW IF EXISTS `dwd_property_contract_building`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_property_contract_building` AS select `a`.`id` AS `id`,`a`.`floor_coefficient` AS `floor_coefficient`,`a`.`contract_id` AS `contract_id`,`a`.`building_level` AS `building_level`,`a`.`building_id` AS `building_id`,`a`.`building_label` AS `building_label`,`a`.`room_ids` AS `room_ids`,`a`.`building_code` AS `building_code`,`a`.`change_type` AS `change_type`,`a`.`rental_area` AS `rental_area`,`b`.`per_contract_id` AS `per_contract_id`,`b`.`per_contract_name` AS `per_contract_name`,`b`.`customer_id` AS `customer_id`,`b`.`customer_id_label` AS `customer_id_label`,`b`.`name` AS `name`,`b`.`code` AS `code`,`b`.`first_code` AS `first_code`,`b`.`person` AS `person`,`b`.`phone` AS `phone`,`b`.`payee_id` AS `payee_id`,`b`.`payee_id_label` AS `payee_id_label`,`b`.`annex` AS `annex`,`b`.`source_type` AS `source_type`,`b`.`source_id` AS `source_id`,`b`.`sign_by` AS `sign_by`,`b`.`sign_date` AS `sign_date`,`b`.`renewal_date` AS `renewal_date`,`b`.`is_locked` AS `is_locked`,`b`.`per_contract_type` AS `per_contract_type`,`b`.`closing_date` AS `closing_date`,`b`.`effective_date` AS `effective_date`,`b`.`email` AS `email`,`b`.`operated_type` AS `operated_type`,`b`.`dept_id` AS `dept_id`,`b`.`lease_change_id` AS `lease_change_id`,`b`.`tenant_id` AS `tenant_id`,`b`.`park_id` AS `park_id`,`b`.`status` AS `status`,(case `b`.`status` when 0 then '暂存' when 1 then '审批中' when 2 then '未生效' when 3 then '生效中' when 4 then '已变更' when 5 then '已转租' when 6 then '已退租' when 7 then '已失效' end) AS `status_desc`,`b`.`create_by` AS `create_by`,`b`.`create_time` AS `create_time`,`b`.`update_by` AS `update_by`,`b`.`update_time` AS `update_time` from (`pai_contract`.`property_contract_building` `a` join `pai_contract`.`property_contract` `b` on((`a`.`contract_id` = `b`.`id`))) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_purchase_intention`
--

/*!50001 DROP VIEW IF EXISTS `dwd_purchase_intention`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_purchase_intention` AS select `a`.`id` AS `id`,`a`.`enterprise_id` AS `enterprise_id`,`a`.`enterprise_name` AS `enterprise_name`,`a`.`concat_person` AS `concat_person`,`a`.`concat_phone` AS `concat_phone`,`a`.`source_id` AS `source_id`,`a`.`area` AS `area`,`a`.`unit_price` AS `unit_price`,`a`.`total_price` AS `total_price`,`a`.`estimate_value` AS `estimate_value`,`a`.`estimate_into_time` AS `estimate_into_time`,`a`.`other_focus` AS `other_focus`,`a`.`dept_id` AS `dept_id`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_pushed` AS `is_pushed`,`a`.`config_id` AS `config_id`,`a`.`tags` AS `tags`,`a`.`park_name` AS `park_name`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_by_name` AS `create_by_name`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_business`.`purchase_intention` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_purchase_intention_focus`
--

/*!50001 DROP VIEW IF EXISTS `dwd_purchase_intention_focus`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_purchase_intention_focus` AS select `a`.`id` AS `id`,`a`.`intention_id` AS `intention_id`,`a`.`focus_id` AS `focus_id`,`a`.`focus_name` AS `focus_name`,`a`.`focus_items` AS `focus_items`,`a`.`focus_item_names` AS `focus_item_names`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_business`.`purchase_intention_focus` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_purchase_subscribe`
--

/*!50001 DROP VIEW IF EXISTS `dwd_purchase_subscribe`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_purchase_subscribe` AS select `a`.`id` AS `id`,`a`.`name` AS `name`,`a`.`enterprise_id` AS `enterprise_id`,`a`.`enterprise_name` AS `enterprise_name`,`a`.`subscribe_date` AS `subscribe_date`,`a`.`contracts_num` AS `contracts_num`,`a`.`follower` AS `follower`,`a`.`follower_name` AS `follower_name`,`a`.`attachment` AS `attachment`,`a`.`settle_park` AS `settle_park`,`a`.`settle_park_name` AS `settle_park_name`,`a`.`contract_id` AS `contract_id`,`a`.`contract_name` AS `contract_name`,`a`.`dept_id` AS `dept_id`,`a`.`is_pushed` AS `is_pushed`,`a`.`payee_id` AS `payee_id`,`a`.`payee_name` AS `payee_name`,`a`.`contact_name` AS `contact_name`,`a`.`contact_phone` AS `contact_phone`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_business`.`purchase_subscribe` `a` where ((1 = 1) and (`a`.`is_deleted` = 0) and (`a`.`status` = 0)) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_purchase_subscribe_room`
--

/*!50001 DROP VIEW IF EXISTS `dwd_purchase_subscribe_room`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_purchase_subscribe_room` AS select `a`.`id` AS `id`,`a`.`room_id` AS `room_id`,`a`.`room_name` AS `room_name`,`a`.`path` AS `path`,`a`.`area_covered` AS `area_covered`,`a`.`build_area` AS `build_area`,`a`.`unit_price` AS `unit_price`,`a`.`total_price` AS `total_price`,`a`.`billable_area` AS `billable_area`,`b`.`name` AS `name`,`b`.`enterprise_id` AS `enterprise_id`,`b`.`enterprise_name` AS `enterprise_name`,`b`.`subscribe_date` AS `subscribe_date`,`b`.`contracts_num` AS `contracts_num`,`b`.`follower` AS `follower`,`b`.`follower_name` AS `follower_name`,`b`.`attachment` AS `attachment`,`b`.`settle_park` AS `settle_park`,`b`.`settle_park_name` AS `settle_park_name`,`b`.`contract_id` AS `contract_id`,`b`.`contract_name` AS `contract_name`,`b`.`dept_id` AS `dept_id`,`b`.`is_pushed` AS `is_pushed`,`b`.`payee_id` AS `payee_id`,`b`.`payee_name` AS `payee_name`,`b`.`contact_name` AS `contact_name`,`b`.`contact_phone` AS `contact_phone`,`b`.`tenant_id` AS `tenant_id`,`b`.`park_id` AS `park_id`,`b`.`is_deleted` AS `is_deleted`,`b`.`status` AS `status`,`b`.`create_by` AS `create_by`,`b`.`create_time` AS `create_time`,`b`.`update_by` AS `update_by`,`b`.`update_time` AS `update_time` from (`pai_business`.`purchase_subscribe_room` `a` join `pai_business`.`purchase_subscribe` `b` on((`a`.`id` = `b`.`id`))) where ((1 = 1) and (`b`.`status` = 0)) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_receivable_items`
--

/*!50001 DROP VIEW IF EXISTS `dwd_receivable_items`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_receivable_items` AS select concat(`a`.`bill_month`,'-01') AS `bill_date`,`a`.`id` AS `id`,`a`.`receivable_id` AS `receivable_id`,`a`.`room_id` AS `room_id`,`a`.`fee_item_id` AS `fee_item_id`,`a`.`start_date` AS `start_date`,`a`.`end_date` AS `end_date`,`a`.`receivable_amount` AS `receivable_amount`,`a`.`adjust_amount` AS `adjust_amount`,`a`.`total_amount` AS `total_amount`,`a`.`received_amount` AS `received_amount`,`a`.`late_fee` AS `late_fee`,`a`.`customer_id` AS `customer_id`,`a`.`tenant_id` AS `tenant_id`,`a`.`room_path` AS `room_path`,`a`.`park_id` AS `park_id`,`a`.`payee_id` AS `payee_id`,`a`.`status` AS `status`,`a`.`customer_name` AS `customer_name`,`a`.`fee_name` AS `fee_name`,`a`.`payee_name` AS `payee_name`,`a`.`late_fee_date` AS `late_fee_date`,`a`.`source_type` AS `source_type`,`a`.`bill_month` AS `bill_month`,`a`.`contract_id` AS `contract_id`,`a`.`discount` AS `discount`,`a`.`rent_free` AS `rent_free`,`a`.`message_status` AS `message_status`,`a`.`late_fee_received` AS `late_fee_received`,`a`.`unit_price` AS `unit_price`,`a`.`area` AS `area`,`a`.`usage_amount` AS `usage_amount`,`a`.`credit_date` AS `credit_date`,`a`.`credit_period` AS `credit_period`,`a`.`fee_type` AS `fee_type`,`a`.`last_fee_date` AS `last_fee_date`,`a`.`create_by` AS `create_by`,`a`.`is_deleted` AS `is_deleted`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_finance`.`receivable_items` `a` where ((`a`.`is_deleted` = 0) and (`a`.`status` = 1)) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_room`
--

/*!50001 DROP VIEW IF EXISTS `dwd_room`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_room` AS select `m`.`id` AS `id`,`m`.`park_id` AS `park_id`,`m`.`renting_selling` AS `renting_selling`,(case `m`.`renting_selling` when 0 then '可租' when 1 then '可售' when 2 then '可租' when 3 then '自用' else `m`.`renting_selling` end) AS `renting_selling_desc`,`m`.`room_code` AS `room_code`,`m`.`room_name` AS `room_name`,`m`.`area_covered` AS `area_covered`,`m`.`built_area` AS `built_area`,`m`.`house_structure` AS `house_structure`,`m`.`kit_id` AS `kit_id`,`m`.`purpose` AS `purpose`,`m`.`room_describe` AS `room_describe`,`m`.`floor_id` AS `floor_id`,`m`.`image` AS `image`,`m`.`is_order` AS `is_order`,`m`.`tenant_id` AS `tenant_id`,`m`.`is_lock` AS `is_lock`,`m`.`is_deleted` AS `is_deleted`,`m`.`status` AS `status`,(case `m`.`status` when 0 then '空置' when 1 then '已租' when 2 then '已售' when 3 then '已售待租' when '4' then '已售已租' when 5 then '自用' when 6 then '已预定' else `m`.`status` end) AS `room_status`,`m`.`create_by` AS `create_by`,`m`.`create_time` AS `create_time`,`m`.`update_by` AS `update_by`,`m`.`update_time` AS `update_time`,`m`.`purpose_id` AS `purpose_id` from `pai_park_space`.`room` `m` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_sale_contract`
--

/*!50001 DROP VIEW IF EXISTS `dwd_sale_contract`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_sale_contract` AS select `a`.`id` AS `id`,`a`.`associate_id` AS `associate_id`,`a`.`name` AS `name`,`a`.`code` AS `code`,`a`.`customer_id` AS `customer_id`,`a`.`customer_id_label` AS `customer_id_label`,`a`.`copy_count` AS `copy_count`,`a`.`sign_dept_id` AS `sign_dept_id`,`a`.`sign_by` AS `sign_by`,`a`.`sign_date` AS `sign_date`,`a`.`annex` AS `annex`,`a`.`charge_area` AS `charge_area`,`a`.`total_price` AS `total_price`,`a`.`status` AS `status`,`a`.`reason` AS `reason`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_contract`.`sale_contract` `a` where (`a`.`status` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_sale_contract_room`
--

/*!50001 DROP VIEW IF EXISTS `dwd_sale_contract_room`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_sale_contract_room` AS select `a`.`sale_contract_id` AS `sale_contract_id`,`a`.`building_id` AS `building_id`,`a`.`building_id_label` AS `building_id_label`,`a`.`path_name` AS `path_name`,`a`.`price` AS `price`,`a`.`total_price` AS `total_price`,`a`.`area` AS `area`,`a`.`inside_area` AS `inside_area`,`a`.`building_code` AS `building_code`,`b`.`associate_id` AS `associate_id`,`b`.`name` AS `name`,`b`.`code` AS `code`,`b`.`customer_id` AS `customer_id`,`b`.`customer_id_label` AS `customer_id_label`,`b`.`copy_count` AS `copy_count`,`b`.`sign_dept_id` AS `sign_dept_id`,`b`.`sign_by` AS `sign_by`,`b`.`sign_date` AS `sign_date`,`b`.`annex` AS `annex`,`b`.`charge_area` AS `charge_area`,`b`.`status` AS `status`,`b`.`reason` AS `reason`,`b`.`tenant_id` AS `tenant_id`,`b`.`park_id` AS `park_id`,`b`.`create_by` AS `create_by`,`b`.`create_time` AS `create_time`,`b`.`update_by` AS `update_by`,`b`.`update_time` AS `update_time` from (`pai_contract`.`sale_contract_room` `a` join `pai_contract`.`sale_contract` `b` on((`a`.`sale_contract_id` = `b`.`id`))) where (`b`.`status` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_stadium`
--

/*!50001 DROP VIEW IF EXISTS `dwd_stadium`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_stadium` AS select `a`.`id` AS `id`,`a`.`stadium_name` AS `stadium_name`,`a`.`area_source` AS `area_source`,`a`.`scope_of_personal` AS `scope_of_personal`,`a`.`type` AS `type`,`a`.`area` AS `area`,`a`.`contact` AS `contact`,`a`.`phone` AS `phone`,`a`.`maximum` AS `maximum`,`a`.`stadium_num` AS `stadium_num`,`a`.`rule_id` AS `rule_id`,`a`.`address` AS `address`,`a`.`description` AS `description`,`a`.`attach_id` AS `attach_id`,`a`.`book_days` AS `book_days`,`a`.`enable_week` AS `enable_week`,`a`.`scope_of_company` AS `scope_of_company`,`a`.`day_off_status` AS `day_off_status`,`a`.`main_figure` AS `main_figure`,`a`.`latitude_and_longitude` AS `latitude_and_longitude`,`a`.`discount` AS `discount`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_service_center`.`stadium` `a` where (`a`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_sys_dept`
--

/*!50001 DROP VIEW IF EXISTS `dwd_sys_dept`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_sys_dept` AS select `a`.`dept_id` AS `dept_id`,`a`.`parent_id` AS `parent_id`,`a`.`ancestors` AS `ancestors`,`a`.`dept_name` AS `dept_name`,`a`.`order_num` AS `order_num`,`a`.`leader` AS `leader`,`a`.`phone` AS `phone`,`a`.`email` AS `email`,`a`.`status` AS `status`,(case `a`.`status` when 0 then '正常' when 1 then '停用' else `a`.`status` end) AS `status_desc`,`a`.`del_flag` AS `del_flag`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_operate`.`sys_dept` `a` where (`a`.`del_flag` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_temp_car_refill`
--

/*!50001 DROP VIEW IF EXISTS `dwd_temp_car_refill`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_temp_car_refill` AS select `pai_parking`.`temp_car_refill`.`id` AS `id`,`pai_parking`.`temp_car_refill`.`car_num` AS `car_num`,`pai_parking`.`temp_car_refill`.`order_id` AS `order_id`,`pai_parking`.`temp_car_refill`.`unit_price` AS `unit_price`,`pai_parking`.`temp_car_refill`.`pay_money` AS `pay_money`,`pai_parking`.`temp_car_refill`.`pay_money_encryption` AS `pay_money_encryption`,(case `pai_parking`.`temp_car_refill`.`pay_source` when '1' then '支付宝' when '2' then '微信' when '3' then '园付通' else `pai_parking`.`temp_car_refill`.`pay_source` end) AS `pay_source`,`pai_parking`.`temp_car_refill`.`start_time` AS `start_time`,`pai_parking`.`temp_car_refill`.`end_time` AS `end_time`,`pai_parking`.`temp_car_refill`.`pay_time` AS `pay_time`,`pai_parking`.`temp_car_refill`.`pay_water` AS `pay_water`,`pai_parking`.`temp_car_refill`.`time_long` AS `time_long`,`pai_parking`.`temp_car_refill`.`synchronization` AS `synchronization`,`pai_parking`.`temp_car_refill`.`park_id` AS `park_id`,`pai_parking`.`temp_car_refill`.`is_deleted` AS `is_deleted`,`pai_parking`.`temp_car_refill`.`status` AS `status`,`pai_parking`.`temp_car_refill`.`create_by` AS `create_by`,`pai_parking`.`temp_car_refill`.`create_time` AS `create_time`,`pai_parking`.`temp_car_refill`.`update_by` AS `update_by`,`pai_parking`.`temp_car_refill`.`update_time` AS `update_time` from `pai_parking`.`temp_car_refill` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_work_order`
--

/*!50001 DROP VIEW IF EXISTS `dwd_work_order`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_work_order` AS select `t`.`id` AS `id`,`t`.`name` AS `name`,`t`.`order_key` AS `order_key`,`t`.`structure` AS `structure`,`t`.`type_id` AS `type_id`,`t`.`config_id` AS `config_id`,`t`.`description` AS `description`,`t`.`working_hours` AS `working_hours`,`t`.`form_link` AS `form_link`,`t`.`app_form_link` AS `app_form_link`,`t`.`is_release` AS `is_release`,`t`.`tenant_id` AS `tenant_id`,`t`.`park_id` AS `park_id`,`t`.`is_deleted` AS `is_deleted`,`t`.`status` AS `status`,`t`.`create_by` AS `create_by`,`t`.`create_time` AS `create_time`,`t`.`update_by` AS `update_by`,`t`.`update_time` AS `update_time`,`t`.`ent_id` AS `ent_id`,`t`.`is_init` AS `is_init` from `pai_workflow`.`work_order` `t` where (`t`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_work_order_evaluate`
--

/*!50001 DROP VIEW IF EXISTS `dwd_work_order_evaluate`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_work_order_evaluate` AS select `a`.`id` AS `id`,`a`.`instance_id` AS `instance_id`,`a`.`verify_evaluation` AS `verify_evaluation`,`a`.`verify_score` AS `verify_score`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time`,`a`.`ent_id` AS `ent_id` from `pai_workflow`.`work_order_evaluate` `a` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_work_order_instance`
--

/*!50001 DROP VIEW IF EXISTS `dwd_work_order_instance`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_work_order_instance` AS select `t`.`id` AS `id`,`t`.`serial_id` AS `serial_id`,`t`.`title` AS `title`,`t`.`priority` AS `priority`,`t`.`order_id` AS `order_id`,`t`.`biz_id` AS `biz_id`,`t`.`form_link` AS `form_link`,`t`.`app_form_link` AS `app_form_link`,`t`.`pending_state` AS `pending_state`,`t`.`parent_id` AS `parent_id`,`t`.`is_parent` AS `is_parent`,`t`.`flow_id` AS `flow_id`,`t`.`receive_timeout_status` AS `receive_timeout_status`,`t`.`order_timeout_status` AS `order_timeout_status`,`t`.`receive_notice` AS `receive_notice`,`t`.`order_notice` AS `order_notice`,`t`.`receive_notice_status` AS `receive_notice_status`,`t`.`order_notice_status` AS `order_notice_status`,`t`.`enterprise` AS `enterprise`,`t`.`is_close` AS `is_close`,`t`.`is_reject` AS `is_reject`,`t`.`is_revocation` AS `is_revocation`,`t`.`tenant_id` AS `tenant_id`,`t`.`park_id` AS `park_id`,`t`.`is_deleted` AS `is_deleted`,`t`.`status` AS `status`,(case `t`.`status` when 0 then '待受理' when 1 then '待确认' when 2 then '待派单' when 3 then '待接单' when 4 then '待处理' when 5 then '处理中' when 6 then '待验收' when 7 then '已完成' else '' end) AS `status_desc`,`t`.`create_by` AS `create_by`,`t`.`create_time` AS `create_time`,`t`.`update_by` AS `update_by`,`t`.`update_time` AS `update_time`,`t`.`ent_id` AS `ent_id` from `pai_workflow`.`work_order_instance` `t` where (`t`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_work_order_time_consume`
--

/*!50001 DROP VIEW IF EXISTS `dwd_work_order_time_consume`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_work_order_time_consume` AS select `a`.`id` AS `id`,`a`.`history_id` AS `history_id`,`a`.`instance_id` AS `instance_id`,`a`.`start_time` AS `start_time`,`a`.`end_time` AS `end_time`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time`,`a`.`ent_id` AS `ent_id` from `pai_workflow`.`work_order_time_consume` `a` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwd_work_order_type`
--

/*!50001 DROP VIEW IF EXISTS `dwd_work_order_type`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwd_work_order_type` AS select `t`.`id` AS `id`,`t`.`name` AS `name`,`t`.`description` AS `description`,`t`.`tenant_id` AS `tenant_id`,`t`.`park_id` AS `park_id`,`t`.`is_deleted` AS `is_deleted`,`t`.`status` AS `status`,`t`.`create_by` AS `create_by`,`t`.`create_time` AS `create_time`,`t`.`update_by` AS `update_by`,`t`.`update_time` AS `update_time`,`t`.`ent_id` AS `ent_id`,`t`.`is_init` AS `is_init` from `pai_workflow`.`work_order_type` `t` where (`t`.`is_deleted` = 0) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dws_meter_info_by_m`
--

/*!50001 DROP VIEW IF EXISTS `dws_meter_info_by_m`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dws_meter_info_by_m` AS select ifnull(`b`.`dict_label`,'未分类') AS `meter_class_name`,`a`.`park_id` AS `park_id`,`a`.`tenant_id` AS `tenant_id`,year(`a`.`meter_reading_time`) AS `year_key`,month(`a`.`meter_reading_time`) AS `month_key`,sum(`a`.`this_usage`) AS `this_usage`,concat(year(`a`.`meter_reading_time`),'-',month(`a`.`meter_reading_time`),'-01') AS `date_key` from ((select `a`.`id` AS `id`,`a`.`meter_code` AS `meter_code`,`a`.`meter_type` AS `meter_type`,`a`.`meter_name` AS `meter_name`,`a`.`meter_class_id` AS `meter_class_id`,`a`.`cust_id` AS `cust_id`,`a`.`meter_id` AS `meter_id`,`a`.`meter_file_id` AS `meter_file_id`,`a`.`room_code` AS `room_code`,`a`.`room_id` AS `room_id`,`a`.`path_names` AS `path_names`,`a`.`building_id` AS `building_id`,`a`.`built_area` AS `built_area`,`a`.`month` AS `month`,`a`.`last_meter_reading_time` AS `last_meter_reading_time`,`a`.`meter_reading_time` AS `meter_reading_time`,`a`.`last_reading` AS `last_reading`,`a`.`reading` AS `reading`,`a`.`last_usage` AS `last_usage`,`a`.`this_usage` AS `this_usage`,`a`.`last_apex_reading` AS `last_apex_reading`,`a`.`apex_reading` AS `apex_reading`,`a`.`last_peak_reading` AS `last_peak_reading`,`a`.`peak_reading` AS `peak_reading`,`a`.`last_flat_reading` AS `last_flat_reading`,`a`.`flat_reading` AS `flat_reading`,`a`.`last_valley_reading` AS `last_valley_reading`,`a`.`valley_reading` AS `valley_reading`,`a`.`last_apex_usage` AS `last_apex_usage`,`a`.`apex_usage` AS `apex_usage`,`a`.`last_peak_usage` AS `last_peak_usage`,`a`.`peak_usage` AS `peak_usage`,`a`.`last_flat_usage` AS `last_flat_usage`,`a`.`flat_usage` AS `flat_usage`,`a`.`last_valley_usage` AS `last_valley_usage`,`a`.`valley_usage` AS `valley_usage`,`a`.`chain` AS `chain`,`a`.`apex_chain` AS `apex_chain`,`a`.`peak_chain` AS `peak_chain`,`a`.`flat_chain` AS `flat_chain`,`a`.`valley_chain` AS `valley_chain`,`a`.`ranges` AS `ranges`,`a`.`ratio` AS `ratio`,`a`.`share_ratio` AS `share_ratio`,`a`.`shared_type` AS `shared_type`,`a`.`loss` AS `loss`,`a`.`source` AS `source`,`a`.`settlement_status` AS `settlement_status`,`a`.`recheck_status` AS `recheck_status`,`a`.`floor_id` AS `floor_id`,`a`.`area_id` AS `area_id`,`a`.`operator` AS `operator`,`a`.`energy_task_id` AS `energy_task_id`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_park_property`.`meter_info` `a` where (`a`.`is_deleted` = 0)) `a` left join (select `a`.`id` AS `id`,(convert(`a`.`dict_label` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `dict_label`,(convert(`a`.`dict_value` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `dict_value`,`b`.`suite_id` AS `suite_id`,`b`.`suite_code` AS `suite_code`,`b`.`version` AS `version`,`b`.`dict_name` AS `dict_name`,(convert(`b`.`tenant_id` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `tenant_id`,`a`.`dict_id` AS `dict_id` from (`pai_config`.`ext_dict_data` `a` left join `pai_config`.`ext_dict_type` `b` on((`a`.`dict_id` = `b`.`dict_id`))) where ((1 = 1) and (`b`.`dict_name` = '能源表种类') and (`b`.`suite_code` = 'cn.flyrise.park.property') and `b`.`version` in (select max(`pai_config`.`ext_dict_type`.`version`) AS `version` from `pai_config`.`ext_dict_type` where ((1 = 1) and (`pai_config`.`ext_dict_type`.`dict_name` = '能源表种类') and (`pai_config`.`ext_dict_type`.`suite_code` = 'cn.flyrise.park.property'))))) `b` on((`a`.`meter_class_id` = `b`.`dict_value`))) where (year(`a`.`meter_reading_time`) >= (year(now()) - 3)) group by `b`.`dict_label`,`a`.`park_id`,`a`.`tenant_id`,`a`.`park_id`,year(`a`.`meter_reading_time`),month(`a`.`meter_reading_time`),concat(year(`a`.`meter_reading_time`),'-',month(`a`.`meter_reading_time`),'-01') */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dws_meter_info_by_y`
--

/*!50001 DROP VIEW IF EXISTS `dws_meter_info_by_y`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dws_meter_info_by_y` AS select `dws_meter_info_by_m`.`meter_class_name` AS `meter_class_name`,`dws_meter_info_by_m`.`park_id` AS `park_id`,`dws_meter_info_by_m`.`tenant_id` AS `tenant_id`,`dws_meter_info_by_m`.`year_key` AS `year_key`,sum(`dws_meter_info_by_m`.`this_usage`) AS `this_usage`,concat(`dws_meter_info_by_m`.`year_key`,'-01-01') AS `date_key` from (select ifnull(`b`.`dict_label`,'未分类') AS `meter_class_name`,`a`.`park_id` AS `park_id`,`a`.`tenant_id` AS `tenant_id`,year(`a`.`meter_reading_time`) AS `year_key`,month(`a`.`meter_reading_time`) AS `month_key`,sum(`a`.`this_usage`) AS `this_usage`,concat(year(`a`.`meter_reading_time`),'-',month(`a`.`meter_reading_time`),'-01') AS `date_key` from ((select `a`.`id` AS `id`,`a`.`meter_code` AS `meter_code`,`a`.`meter_type` AS `meter_type`,`a`.`meter_name` AS `meter_name`,`a`.`meter_class_id` AS `meter_class_id`,`a`.`cust_id` AS `cust_id`,`a`.`meter_id` AS `meter_id`,`a`.`meter_file_id` AS `meter_file_id`,`a`.`room_code` AS `room_code`,`a`.`room_id` AS `room_id`,`a`.`path_names` AS `path_names`,`a`.`building_id` AS `building_id`,`a`.`built_area` AS `built_area`,`a`.`month` AS `month`,`a`.`last_meter_reading_time` AS `last_meter_reading_time`,`a`.`meter_reading_time` AS `meter_reading_time`,`a`.`last_reading` AS `last_reading`,`a`.`reading` AS `reading`,`a`.`last_usage` AS `last_usage`,`a`.`this_usage` AS `this_usage`,`a`.`last_apex_reading` AS `last_apex_reading`,`a`.`apex_reading` AS `apex_reading`,`a`.`last_peak_reading` AS `last_peak_reading`,`a`.`peak_reading` AS `peak_reading`,`a`.`last_flat_reading` AS `last_flat_reading`,`a`.`flat_reading` AS `flat_reading`,`a`.`last_valley_reading` AS `last_valley_reading`,`a`.`valley_reading` AS `valley_reading`,`a`.`last_apex_usage` AS `last_apex_usage`,`a`.`apex_usage` AS `apex_usage`,`a`.`last_peak_usage` AS `last_peak_usage`,`a`.`peak_usage` AS `peak_usage`,`a`.`last_flat_usage` AS `last_flat_usage`,`a`.`flat_usage` AS `flat_usage`,`a`.`last_valley_usage` AS `last_valley_usage`,`a`.`valley_usage` AS `valley_usage`,`a`.`chain` AS `chain`,`a`.`apex_chain` AS `apex_chain`,`a`.`peak_chain` AS `peak_chain`,`a`.`flat_chain` AS `flat_chain`,`a`.`valley_chain` AS `valley_chain`,`a`.`ranges` AS `ranges`,`a`.`ratio` AS `ratio`,`a`.`share_ratio` AS `share_ratio`,`a`.`shared_type` AS `shared_type`,`a`.`loss` AS `loss`,`a`.`source` AS `source`,`a`.`settlement_status` AS `settlement_status`,`a`.`recheck_status` AS `recheck_status`,`a`.`floor_id` AS `floor_id`,`a`.`area_id` AS `area_id`,`a`.`operator` AS `operator`,`a`.`energy_task_id` AS `energy_task_id`,`a`.`tenant_id` AS `tenant_id`,`a`.`park_id` AS `park_id`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_by` AS `update_by`,`a`.`update_time` AS `update_time` from `pai_park_property`.`meter_info` `a` where (`a`.`is_deleted` = 0)) `a` left join (select `a`.`id` AS `id`,(convert(`a`.`dict_label` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `dict_label`,(convert(`a`.`dict_value` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `dict_value`,`b`.`suite_id` AS `suite_id`,`b`.`suite_code` AS `suite_code`,`b`.`version` AS `version`,`b`.`dict_name` AS `dict_name`,(convert(`b`.`tenant_id` using utf8mb4) collate UTF8MB4_GENERAL_CI) AS `tenant_id`,`a`.`dict_id` AS `dict_id` from (`pai_config`.`ext_dict_data` `a` left join `pai_config`.`ext_dict_type` `b` on((`a`.`dict_id` = `b`.`dict_id`))) where ((1 = 1) and (`b`.`dict_name` = '能源表种类') and (`b`.`suite_code` = 'cn.flyrise.park.property') and `b`.`version` in (select max(`pai_config`.`ext_dict_type`.`version`) AS `version` from `pai_config`.`ext_dict_type` where ((1 = 1) and (`pai_config`.`ext_dict_type`.`dict_name` = '能源表种类') and (`pai_config`.`ext_dict_type`.`suite_code` = 'cn.flyrise.park.property'))))) `b` on((`a`.`meter_class_id` = `b`.`dict_value`))) where (year(`a`.`meter_reading_time`) >= (year(now()) - 3)) group by `b`.`dict_label`,`a`.`park_id`,`a`.`tenant_id`,`a`.`park_id`,year(`a`.`meter_reading_time`),month(`a`.`meter_reading_time`),concat(year(`a`.`meter_reading_time`),'-',month(`a`.`meter_reading_time`),'-01')) `dws_meter_info_by_m` group by `dws_meter_info_by_m`.`meter_class_name`,`dws_meter_info_by_m`.`park_id`,`dws_meter_info_by_m`.`tenant_id`,`dws_meter_info_by_m`.`year_key`,concat(`dws_meter_info_by_m`.`year_key`,'-01-01') */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwt_car_free_manage`
--

/*!50001 DROP VIEW IF EXISTS `dwt_car_free_manage`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwt_car_free_manage` AS select `a`.`source_id` AS `source_id`,`a`.`car_num` AS `car_num`,`a`.`car_contacts` AS `car_contacts`,`a`.`user_id` AS `user_id`,`a`.`car_phone` AS `car_phone`,`a`.`company_name` AS `company_name`,`a`.`company_id` AS `company_id`,`a`.`free_time_encryption` AS `free_time_encryption`,`a`.`free_time` AS `free_time`,`a`.`synchronization` AS `synchronization`,`a`.`car_unique_id` AS `car_unique_id`,`a`.`park_id` AS `park_id`,`a`.`is_renew` AS `is_renew`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_time` AS `update_time`,`a`.`update_by` AS `update_by`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status` from `dwd_car_free_manage` `a` where (1 = 1) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwt_car_in_record`
--

/*!50001 DROP VIEW IF EXISTS `dwt_car_in_record`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwt_car_in_record` AS select `a`.`id` AS `id`,`a`.`car_num` AS `car_num`,`a`.`record_id` AS `record_id`,`a`.`enter_area` AS `enter_area`,`a`.`enter_time` AS `enter_time`,`a`.`park_id` AS `park_id`,`a`.`create_by` AS `create_by`,`a`.`create_time` AS `create_time`,`a`.`update_time` AS `update_time`,`a`.`update_by` AS `update_by`,`a`.`is_deleted` AS `is_deleted`,`a`.`status` AS `status`,`b`.`is_black` AS `is_black`,`b`.`is_free` AS `is_free`,(case when (`b`.`car_num` is not null) then 1 else 0 end) AS `month_car` from (`dwd_car_in_record` `a` left join `dwd_car_manage` `b` on(((`a`.`park_id` = `b`.`park_id`) and (`a`.`car_num` = `b`.`car_num`)))) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwt_cons_enterprise`
--

/*!50001 DROP VIEW IF EXISTS `dwt_cons_enterprise`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwt_cons_enterprise` AS select `pai_operate`.`cons_enterprise`.`ent_id` AS `ent_id`,`pai_operate`.`cons_enterprise`.`ent_name` AS `ent_name`,`pai_operate`.`cons_enterprise`.`ent_code` AS `ent_code`,`pai_operate`.`cons_enterprise`.`ent_us_id` AS `ent_us_id`,`pai_operate`.`cons_enterprise`.`ent_domain` AS `ent_domain`,`pai_operate`.`cons_enterprise`.`ent_trade` AS `ent_trade`,`pai_operate`.`cons_enterprise`.`ent_scale` AS `ent_scale`,`pai_operate`.`cons_enterprise`.`ent_person_phone` AS `ent_person_phone`,`pai_operate`.`cons_enterprise`.`ent_person` AS `ent_person`,`pai_operate`.`cons_enterprise`.`ent_email` AS `ent_email`,`pai_operate`.`cons_enterprise`.`ent_tel` AS `ent_tel`,`pai_operate`.`cons_enterprise`.`ent_fax` AS `ent_fax`,`pai_operate`.`cons_enterprise`.`ent_address` AS `ent_address`,`pai_operate`.`cons_enterprise`.`ent_status` AS `ent_status`,`pai_operate`.`cons_enterprise`.`create_by` AS `create_by`,`pai_operate`.`cons_enterprise`.`create_time` AS `create_time`,`pai_operate`.`cons_enterprise`.`update_by` AS `update_by`,`pai_operate`.`cons_enterprise`.`update_time` AS `update_time`,`pai_operate`.`cons_enterprise`.`remark` AS `remark`,`pai_operate`.`cons_enterprise`.`ent_logo` AS `ent_logo`,`pai_operate`.`cons_enterprise`.`ent_type` AS `ent_type`,`pai_operate`.`cons_enterprise`.`ent_park_id` AS `ent_park_id`,`pai_operate`.`cons_enterprise`.`admin_name` AS `admin_name`,`pai_operate`.`cons_enterprise`.`admin_phone` AS `admin_phone`,`pai_operate`.`cons_enterprise`.`virtual_type` AS `virtual_type`,`pai_operate`.`cons_enterprise`.`group_preset_id` AS `group_preset_id`,`pai_operate`.`cons_enterprise`.`group_id` AS `group_id`,`pai_operate`.`cons_enterprise`.`ent_class_id` AS `ent_class_id`,`pai_operate`.`cons_enterprise`.`source` AS `source`,`pai_operate`.`cons_enterprise`.`source_name` AS `source_name` from `pai_operate`.`cons_enterprise` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwt_enterprise`
--

/*!50001 DROP VIEW IF EXISTS `dwt_enterprise`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwt_enterprise` AS select `pai_enterprise`.`enterprise`.`id` AS `enterprise_id`,`pai_enterprise`.`enterprise`.`id` AS `id`,`pai_enterprise`.`enterprise`.`name` AS `name`,`pai_enterprise`.`enterprise`.`alias` AS `alias`,`pai_enterprise`.`enterprise`.`history_names` AS `history_names`,`pai_enterprise`.`enterprise`.`eng_name` AS `eng_name`,`pai_enterprise`.`enterprise`.`tax_number` AS `tax_number`,`pai_enterprise`.`enterprise`.`credit_code` AS `credit_code`,`pai_enterprise`.`enterprise`.`industry` AS `industry`,`pai_enterprise`.`enterprise`.`estiblish_time` AS `estiblish_time`,`pai_enterprise`.`enterprise`.`from_time` AS `from_time`,`pai_enterprise`.`enterprise`.`to_time` AS `to_time`,`pai_enterprise`.`enterprise`.`reg_status` AS `reg_status`,`pai_enterprise`.`enterprise`.`is_micro_ent` AS `is_micro_ent`,`pai_enterprise`.`enterprise`.`org_number` AS `org_number`,`pai_enterprise`.`enterprise`.`category_big` AS `category_big`,`pai_enterprise`.`enterprise`.`legal_person_name` AS `legal_person_name`,`pai_enterprise`.`enterprise`.`reg_capital` AS `reg_capital`,`pai_enterprise`.`enterprise`.`reg_location` AS `reg_location`,`pai_enterprise`.`enterprise`.`origin_id` AS `origin_id`,`pai_enterprise`.`enterprise`.`is_sync` AS `is_sync`,`pai_enterprise`.`enterprise`.`ent_id` AS `ent_id`,`pai_enterprise`.`enterprise`.`park_id` AS `park_id`,`pai_enterprise`.`enterprise`.`is_deleted` AS `is_deleted`,`pai_enterprise`.`enterprise`.`status` AS `status`,`pai_enterprise`.`enterprise`.`create_by` AS `create_by`,`pai_enterprise`.`enterprise`.`create_time` AS `create_time`,`pai_enterprise`.`enterprise`.`update_by` AS `update_by`,`pai_enterprise`.`enterprise`.`update_time` AS `update_time`,`pai_enterprise`.`enterprise`.`category` AS `category`,`pai_enterprise`.`enterprise`.`category_middle` AS `category_middle`,`pai_enterprise`.`enterprise`.`category_small` AS `category_small`,`pai_enterprise`.`enterprise`.`history_name_list` AS `history_name_list`,`pai_enterprise`.`enterprise`.`staff_num_range` AS `staff_num_range`,`pai_enterprise`.`enterprise`.`social_staff_num` AS `social_staff_num`,`pai_enterprise`.`enterprise`.`business_scope` AS `business_scope`,`pai_enterprise`.`enterprise`.`type` AS `type`,`pai_enterprise`.`enterprise`.`company_org_type` AS `company_org_type`,`pai_enterprise`.`enterprise`.`tags` AS `tags`,`pai_enterprise`.`enterprise`.`percentile_score` AS `percentile_score`,`pai_enterprise`.`enterprise`.`base` AS `base`,`pai_enterprise`.`enterprise`.`city` AS `city`,`pai_enterprise`.`enterprise`.`district` AS `district`,`pai_enterprise`.`enterprise`.`reg_number` AS `reg_number`,`pai_enterprise`.`enterprise`.`reg_capital_currency` AS `reg_capital_currency`,`pai_enterprise`.`enterprise`.`actual_capital` AS `actual_capital`,`pai_enterprise`.`enterprise`.`actual_capital_currency` AS `actual_capital_currency`,`pai_enterprise`.`enterprise`.`regInstitute` AS `regInstitute`,`pai_enterprise`.`enterprise`.`approved_time` AS `approved_time`,`pai_enterprise`.`enterprise`.`bond_num` AS `bond_num`,`pai_enterprise`.`enterprise`.`bond_name` AS `bond_name`,`pai_enterprise`.`enterprise`.`used_bond_name` AS `used_bond_name`,`pai_enterprise`.`enterprise`.`bond_type` AS `bond_type`,`pai_enterprise`.`enterprise`.`revoke_date` AS `revoke_date`,`pai_enterprise`.`enterprise`.`revoke_reason` AS `revoke_reason`,`pai_enterprise`.`enterprise`.`cancel_date` AS `cancel_date`,`pai_enterprise`.`enterprise`.`cancel_reason` AS `cancel_reason`,`pai_enterprise`.`enterprise`.`logo` AS `logo`,`pai_enterprise`.`enterprise`.`is_fill` AS `is_fill`,`pai_enterprise`.`enterprise`.`tenant_id` AS `tenant_id`,(case when (regexp_substr(`pai_enterprise`.`enterprise`.`reg_capital`,'[0-9]+([.][0-9]+)?') >= 5000) then '5千万以上' when ((regexp_substr(`pai_enterprise`.`enterprise`.`reg_capital`,'[0-9]+([.][0-9]+)?') < 5000) and (regexp_substr(`pai_enterprise`.`enterprise`.`reg_capital`,'[0-9]+([.][0-9]+)?') >= 1000)) then '1千-5千万' when ((regexp_substr(`pai_enterprise`.`enterprise`.`reg_capital`,'[0-9]+([.][0-9]+)?') < 1000) and (regexp_substr(`pai_enterprise`.`enterprise`.`reg_capital`,'[0-9]+([.][0-9]+)?') >= 500)) then '5百-1千万' when ((regexp_substr(`pai_enterprise`.`enterprise`.`reg_capital`,'[0-9]+([.][0-9]+)?') < 500) and (regexp_substr(`pai_enterprise`.`enterprise`.`reg_capital`,'[0-9]+([.][0-9]+)?') >= 100)) then '1百-5百万' else '1百万以下' end) AS `reg_capital_level` from `pai_enterprise`.`enterprise` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `dwt_parking_payment`
--

/*!50001 DROP VIEW IF EXISTS `dwt_parking_payment`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `dwt_parking_payment` AS select `dwd_temp_car_refill`.`park_id` AS `park_id`,`dwd_temp_car_refill`.`pay_time` AS `pay_time`,`dwd_temp_car_refill`.`pay_money` AS `pay_money`,0 AS `last_year_money`,`dwd_temp_car_refill`.`car_num` AS `car_num`,`dwd_temp_car_refill`.`pay_source` AS `pay_source`,'临停' AS `pay_type`,'空白' AS `area_name` from `dwd_temp_car_refill` union all select `dwd_temp_car_refill`.`park_id` AS `park_id`,(`dwd_temp_car_refill`.`pay_time` + interval 1 year) AS `pay_time`,0 AS `pay_money`,`dwd_temp_car_refill`.`pay_money` AS `last_year_money`,`dwd_temp_car_refill`.`car_num` AS `car_num`,`dwd_temp_car_refill`.`pay_source` AS `pay_source`,'临停' AS `pay_type`,'空白' AS `area_name` from `dwd_temp_car_refill` union all select `dwd_month_car_refill`.`park_id` AS `park_id`,`dwd_month_car_refill`.`pay_time` AS `pay_time`,`dwd_month_car_refill`.`pay_money` AS `pay_money`,0 AS `last_year_money`,`dwd_month_car_refill`.`car_num` AS `car_num`,`dwd_month_car_refill`.`pay_source` AS `pay_source`,'月卡' AS `pay_type`,`dwd_month_car_refill`.`area_name` AS `area_name` from `dwd_month_car_refill` union all select `dwd_month_car_refill`.`park_id` AS `park_id`,(`dwd_month_car_refill`.`pay_time` + interval 1 year) AS `pay_time`,0 AS `pay_money`,`dwd_month_car_refill`.`pay_money` AS `last_year_money`,`dwd_month_car_refill`.`car_num` AS `car_num`,`dwd_month_car_refill`.`pay_source` AS `pay_source`,'月卡' AS `pay_type`,`dwd_month_car_refill`.`area_name` AS `area_name` from `dwd_month_car_refill` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `temp_clue_source_channel`
--

/*!50001 DROP VIEW IF EXISTS `temp_clue_source_channel`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `temp_clue_source_channel` AS select `a`.`id` AS `id`,`a`.`dict_label` AS `dict_label`,`a`.`dict_value` AS `dict_value`,`b`.`suite_id` AS `suite_id`,`b`.`suite_code` AS `suite_code`,`b`.`version` AS `version`,`b`.`dict_name` AS `dict_name`,`b`.`tenant_id` AS `tenant_id`,`a`.`dict_id` AS `dict_id` from (`pai_config`.`ext_dict_data` `a` left join `pai_config`.`ext_dict_type` `b` on((`a`.`dict_id` = `b`.`dict_id`))) where ((1 = 1) and (`b`.`suite_code` = 'cn.flyrise.business') and (`b`.`dict_name` = '来源渠道')) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `temp_room_purpose`
--

/*!50001 DROP VIEW IF EXISTS `temp_room_purpose`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_0900_ai_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`pai-screen-1782283103811162112`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `temp_room_purpose` AS select `a`.`id` AS `id`,`a`.`dict_label` AS `dict_label`,`a`.`dict_value` AS `dict_value`,`b`.`suite_id` AS `suite_id`,`b`.`suite_code` AS `suite_code`,`b`.`version` AS `version`,`b`.`dict_name` AS `dict_name`,`b`.`tenant_id` AS `tenant_id`,`a`.`dict_id` AS `dict_id` from (`pai_config`.`ext_dict_data` `a` left join `pai_config`.`ext_dict_type` `b` on((`a`.`dict_id` = `b`.`dict_id`))) where ((1 = 1) and (`b`.`suite_code` = 'cn.flyrise.park.space') and (`b`.`dict_name` = '房间用途')) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2024-10-16 12:38:01
